extends Control

# class member variables go here, for example:
# var a = 2
# var b = "textvar"

var gsvar
onready var g = get_node("/root/global")
onready var settings_grid= get_node("sc/gc")
var groups = {}
var config

func _ready():
  gsvar = get_node("/root/gamestate")
	# Called every time the node is added to the scene.
	# Initialization here
  config = ConfigFile.new()
  var err = config.load("user://dbgentries.cfg")
#  populate_entries()
#  self.connect("hide", self, "_on_hide");
  set_pause_mode(2)

func add_entry(group, id):
  var i = {"group":group, "name":id, "default":true}
  i.value = config.get_value(i.group, i.name)
  if g.is_null(i.value):
    i.value = true
    config.set_value( i.group, i.name, true)
  g.debug_entry_enabled[i.group][i.name] = i.value
#  i.value = config.get_value(i.group, i.name, i.default)
  var groupcontainer
  if groups.keys().has(i.group):
    groupcontainer = groups[i.group]
  else:
    groupcontainer = VBoxContainer.new()
    groupcontainer.set_name(i.group)
    var glabel = Label.new()
    var font = load("fonts/biglabel.fnt")
    glabel.add_font_override( "font", font )
    glabel.set_text(i.group.to_upper())
    groupcontainer.add_child(glabel)
    settings_grid.add_child(groupcontainer)
    groups[i.group] = groupcontainer
  var settingcontainer = HBoxContainer.new()
  settingcontainer.set_name(i.name)
  var stlabel = Label.new()
  stlabel.set_text(i.name)
  settingcontainer.add_child(stlabel)
  var stcontrol
  stcontrol = CheckBox.new()
  stcontrol.set_pressed(i.value)
  stcontrol.connect("toggled", self, "entry_toggled", [i])
  stlabel.set_ignore_mouse(false)
#  stlabel.set_tooltip(i.what)
  settingcontainer.add_child(stcontrol)
  groupcontainer.add_child(settingcontainer)

#  save_settings()

func entry_toggled(state, i):
  g.debug_entry_enabled[i.group][i.name] = state
  config.set_value( i.group, i.name, state)
  if not state and g._store.scrn_dbg.has(i.name):
    g._store["scrn_dbg"].erase(i.name)

func populate_entries():
#  var lines = g.get_config_lines()
#  var config = ConfigFile.new()
#  var err = config.load("user://dbgentries.cfg")
  var lines = []
#  var settings_grid= get_node("sc/gc")
#  var groups = {}
  for i in lines:
#    if config.has_section_key(i.group, i.name):
    add_entry(i)

func save_settings():
#  var new_config = ConfigFile.new()
#  var grid = get_node("sc/gc")
#  for i in grid.get_children():
#    for j in i.get_children():
#      if !j.is_type("Container"):
#        continue
#
#      var setting_name = j.get_children()[0].get_text()
#      var setting_value
#      var stcontrol = j.get_children()[1]
#      if stcontrol.get_type() == "CheckBox":
#        setting_value = stcontrol.is_pressed()
#      new_config.set_value( i.get_name(), j.get_name(), setting_value)
#  new_config.save("user://dbgentries.cfg")
#  config = new_config
  config.save("user://dbgentries.cfg")
#  gsvar.save_config()
#  gsvar.load_config()

func _exit_tree():
  pass
  g.report("WALKING AWAY", [], 0 , 1000, {"only":false})
  save_settings()

#func _notification(what):
#  print(what)
