extends Node

var tank
var instructions = []
var instructions_visualize = false
var instructions_fake = false
var instructions_start = false
var wait_instruction_running = false
var instructions_last_dest = [Vector3(), 0]
var instructions_fake_elapsed_time = 0
var bot_reset_position = Vector3()


func _init():
  is_bot = true
  event_times = {"last_reverse":0,"last_reverse_x":0, "last_evade_align":0, "last_escape_align":0, "last_evade_kill_intent":0, "last_chasing":0, "last_shoot":OS.get_ticks_msec() + 5000, "last_vary":0, "wait_instruction":0, "last_p_moving":0}
  event_delays = {"last_shoot":150}


func _ready():
#  ._ready()
#  get_node("/root/world/gui/objectsname").add_object(self)
  set_process(true);
  set_fixed_process(true);

func positioner(position_array):
  var pos = position_array[0]
  var rot = position_array[1]
  tank.get_node("col_capsule").set_rotation(Vector3(0, float(rot),0));
#  var p = pos
  tank.new_spawn = {"pos":pos, "rot":rot}


func instr_save_position():
  bot_reset_position = [tank.get_translation(), tank.body_rotation]
  instructions_last_dest = bot_reset_position

func instr_reset_position():
  positioner(bot_reset_position)
  instructions_last_dest = bot_reset_position
#  g.report("bot_reset_positionvar", [bot_reset_position], 0 , 1000, {"only":true})
func instr_wait(t):
  var done = false
  if not wait_instruction_running:
    time_since_up("wait_instruction")
    wait_instruction_running = true
  if time_since("wait_instruction", t):
    done = true
    wait_instruction_running = false
  return done


func instr_speed(fraction):
  tank.stick_y = g.f2stick(fraction)


func instr_turn(fraction):
  tank.stick_x = g.f2stick(fraction)


func set_instructions(instr,visualize=true, fake=true):
  instructions = instr
  instructions_visualize = visualize
  instructions_fake = fake
  instructions_start = OS.get_ticks_msec()



func draw_expected_path(duration, type="tank", opts={}):
  var default_opts = {'maximize':false,
 'reverse_x':false, 'reverse_y':false,'draw':true}
  opts = g.mergedicts(default_opts, opts)
  var types = ["tank", "shot"]
#  var position = xz(get_translation())
  var position = xz(instructions_last_dest[0])
#  var angle = body_rotation
  var angle = instructions_last_dest[1]
  var v = g.f2v(g.stick2f(tank.stick_y))
  var av = g.f2av(g.stick2f(tank.stick_x))
  if opts.maximize:
    v = g.f2v(sign(tank.stick_y))
    av = g.f2av(sign(tank.stick_x))
  if opts.reverse_x:
    av = - av
  if opts.reverse_y:
    v = - v

  var step = 0.2
  var time_elapsed = (OS.get_ticks_msec() - instructions_start) / 1000.0
  if instructions_fake:
    time_elapsed = instructions_fake_elapsed_time / 1000.0
    g.report("time time_elapsed fake", [time_elapsed], 0 , 0, {"only":true})
  if type == "shot":
    av = 0.001
    v = 100
    duration = 2
  var expected_path = g.gen_expected_destinations(position, angle, av, v, duration,step)
  if opts.draw:
    g.draw_destinations(
      expected_path , time_elapsed / step
    )
  return expected_path


func move_instructions():
  var viz = instructions_visualize
  if not instructions.empty():
    g.report("remaining bot instructions", instructions, 1 , 0, {"only":false, "changed":true})
    var cur = instructions[0]
    if cur[0] == "wait":
      if viz and not wait_instruction_running:
        var duration = cur[1]
        instructions_last_dest = draw_expected_path(duration/1000.0, "tank", {'maximize':true})[-1]
#        visualize_tank_path
      if instructions_fake:
        instructions_fake_elapsed_time += cur[1]
#        pass
      else:
        var done = instr_wait(cur[1])
        if not done:
  #        instructions.pop_front()
          return
        else:
          instructions_last_dest = [get_translation(), body_rotation]
#      if not wait_instruction_running:
#        time_since_up("wait_instruction")
#        wait_instruction_running = true
#      if not time_since("wait_instruction", cur[1]):
#        return
#      else:
#        wait_instruction_running = false
#        instructions.pop_front()
#        return
    elif cur[0] == "shoot":
      if viz:
        draw_expected_path(0,"shot")
#        pass
#        visualize_shot_path
      if not instructions_fake:
        tank.shoot_think()
    elif cur[0] == "stop":
      tank.stick_x = 0
      tank.stick_y = 0
    elif cur[0] == "save":
      instr_save_position()
    elif cur[0] == "reset":
      instr_reset_position()
    elif cur[0] == "repeat":
      var endidx = instructions.find("end")
      var repeat_instructions = g.array_range(instructions, 1, endidx-2)
      g.report("find repeat instructions", [repeat_instructions], 0 , 0, {"only":false})
      for i in range(cur[1]-1):
        var x = 0
        for j in repeat_instructions:
          x += 1
          instructions.insert(x, j)
    elif cur[0] == "fn":
      callv(cur[1], g.array_range(cur, 2, -1))
    elif cur[0] == "speed":
      instr_speed(cur[1])
    elif cur[0] == "turn":
      instr_turn(cur[1])
    elif cur[0] == "set":
      set(cur[1], cur[2])
    elif inst2dict(self).has(cur[0]):
      set(cur[0], cur[1])
    else:
      g.report("unhandled instruction", [cur], 0 , 0, {"only":true})
    instructions.pop_front()
  else:
    instructions_fake = false
    instructions_visualize = false
    instructions_fake_elapsed_time = 0
