extends "res://scripts/tank.gd"

var freeze_lagmate = false
var lagmate_pos = Vector3()
var aim_x = 0
#var crossh_shift = 7.55
var radar3d = true
var kb_move = false
var current_zoom = 100000
var target_zoom = 450
var last_zoom = 450
var zoom_levels = {"close":90,"dodge":200, "normal":450, "far":1000}
var is_aiming = true;
var tank_trace_scene = load("res://prefabs/tank_trace.tscn");
var camera_range = 40;
var radar_camera_range = 100;
var camera_pivot_range = 0.0;
var camera_position = Vector3();
var camera_target = Vector3();
var top_cam_elevation = 300
var curs_posx = 0;
var curs_posy = 0;
var trajectory_shapes = []
var psq
var predict_landing_next_sync = false
#var landing_timer
var landing_marks = []
var kb_enabled = true
#onready var motion_bounds = gsvar.config["mousebox_size"];
#onready var deadzone_bounds = gsvar.config["deadzone_size"];
onready var ui_health = get_node("/root/world/gui/healthbar/health");
onready var ui_ammo = get_node("/root/world/gui/ammo/count");
onready var ui_elevation = get_node("/root/world/gui/elevation/count");
onready var ui_fps = get_node("/root/world/gui/fps/count");
#onready var ui_crosshair = get_node("/root/world/gui/crosshair");
onready var ui_crosshair3 = get_node("/root/world/gui/crosshair3");
onready var ui_crosshair_tex = get_node("/root/world/gui/crosshair1/tex");
onready var c_h_sz = ui_crosshair_tex.get_size().x / 2
onready var camera = get_node("camera");
onready var camera_instance = get_node("camera/cam"); # tank camera
onready var active_camera_instance = get_node("camera/cam");
onready var follow_player = me
#onready var radar_camera = get_node("/root/world/radarframe/Viewport/MyCamera") # view world static objects on radar
#onready var radar_camera2 = get_node("/root/world/radar_bg3/radarframe2/Viewport/MyCamera") # view moving objects on radar

#const _phys = {"lv":Vector3(), "rotation":0,  "moving":false, "jumping":false,"falling":false, "in_air":false, "touching":false, "side_touching":false, "resting":false, "on_floor":false, "on_pyra":false, "top_touching":false, "above_pyra":false, "tick":0}
#signal player_got_hit(killer)
#
#export (FixedMaterial) var trajectory_mat = null

var target_player
var action_manager
var situation = {"P":{}, "B":{}}
var rel_enemy_motion = [null,null,null]
var situation_buffer = []
var stopped = false

func _ready():
#  gsvar.change_focus("GC")
  event_times['last_calc_move'] = 0
  reload_time = 2
  create_mousebox()
#  create_timer()
  ui_ammo.set_text(str(shots_limit) + "/" + str(shots_limit) )
  create_jump_trajectory_shapes()
  if self.get_name() == str(net.uid):
    get_node('body/Tank').set_hidden(true)
    g.report("hiding elevation for self", [], 0 , 1000, {"only":false})
    get_node("body/radar_elevation").hide()
  if self.get_name() != str(net.uid):
    get_node("/root/world/gui/objectsname").add_object(self)
  get_node("body/radar_elevation").set_scale(Vector3())
  if !is_node_master:
    get_node("projected_pos/area").connect("body_enter", self, "lag_mate_collided")
    get_node("projected_pos/area").connect("body_exit", self, "lag_mate_uncollided")
#  set_pause_mode(2)
  set_process(true);
  set_fixed_process(true);


func lag_mate_collided(b):
  g.report("lag mate col", [b.get_name()], 1 , 1000, {"only":false})
  if b.get_type() == "StaticBody":
    freeze_lagmate = true


func lag_mate_uncollided(b):
  g.report("lag mate leave", [b.get_name()], 1 , 1000, {"only":false})
  if b.get_type() == "StaticBody":
    freeze_lagmate = false

#
func _config_master():
  if is_node_master:
    set_process_input(true);
  if (!is_node_master):
    camera.set_active(true);
#    camera_instance.make_current()
    var own_id = net.uid;
    # don't let new players steal camera
    if gsvar.player_by_id(own_id):
      return
      gsvar.player_by_id(own_id).camera_instance.make_current()
#    camera.queue_free();
  else:
#    camera.set_active(true);
    camera_instance.make_current()
    get_node("projected_pos").hide()


func create_mousebox():
  get_node("/root/world/gui/crosshair/mousebox").set('polygon', [Vector2(-motion_bounds, -motion_bounds), Vector2(-motion_bounds, motion_bounds), Vector2(motion_bounds, motion_bounds), Vector2(motion_bounds, -motion_bounds)])
  get_node("/root/world/gui/crosshair/deadzone").set('polygon', [Vector2(-deadzone_bounds, -deadzone_bounds), Vector2(-deadzone_bounds, deadzone_bounds), Vector2(deadzone_bounds, deadzone_bounds), Vector2(deadzone_bounds, -deadzone_bounds)])


#func create_timer():
#  timer = Timer.new()
#  timer.set_one_shot(false)
#  timer.set_timer_process_mode(0)
#  timer.set_wait_time(3)
#  timer.set_one_shot(true)
#  add_child(timer)

#
#func on_timeout():
#  pass
#
#
#func get_object_name():
#  return player_name;


func _input(ie):
  if paused:
    return
#  if gsvar.focus[-1] == "game" :
  if gsvar.active_focus == "GC":

    movement_input(ie)
    if [InputEvent.MOUSE_BUTTON, InputEvent.KEY].has(ie.type):
      if ie.is_action_pressed('shoot') and not ie.control and not ie.alt and not ie.shift:
        shoot_think();
      if ie.is_action_pressed('aim') and is_node_master:
        is_aiming = !is_aiming;
        get_node('body/Tank').set_hidden(is_aiming)
      if ie.is_action_pressed('radarzoom_far'):
        radarzoom("far")
      if ie.is_action_pressed('radarzoom_normal'):
        radarzoom("normal")
      if ie.is_action_pressed('radarzoom_close'):
        radarzoom("close")
      if ie.is_action_released('radarzoom_toggle'):
        radarzoom_restore()
      if ie.is_action_pressed('radarzoom_toggle'):
        pass
      if ie.is_action_pressed('radarzoom_toggle'):
        radar3d = !radar3d
      if ie.is_action_pressed('topcam_elevation_up'):
        top_cam_elevation += 10
      if ie.is_action_pressed('topcam_elevation_down'):
        top_cam_elevation -= 10

  else:
    stick_y = 0
    stick_x = 0


func update_radar(delta):
  if not is_node_master:
    return
  var vp = get_node("/root/world/radarframe/Viewport");
  var render = vp.get_render_target_texture();
  get_node("/root/world/radarframe_map").set_texture(render);
  var r_pos = radar_camera.unproject_position(get_global_transform().origin)
  r_pos.x -= (radar_player.get_size().x / 2.0 + 0.5)
  r_pos.y -= (radar_player.get_size().y / 2.0 - 1)
  radar_player.set_pos(r_pos)
  var tankeye = get_node("body/shoot_pos").get_global_transform().origin;
  var look_from_rad = tankeye;
  if phys.above_pyra or (phys.on_pyra and not phys.on_floor):
    radarzoom("close", false)
  elif check_close_bullet():
    radarzoom("dodge", false)
  else:
    radarzoom_restore()
  if radar3d == false or  phys.above_pyra or (phys.on_pyra and not phys.on_floor) or check_close_bullet() :
    radar_camera_range = lerp(radar_camera_range, 3, 20*delta);
  else:
    radar_camera_range = lerp(radar_camera_range, 100, 20*delta);
  look_from_rad.x -= radar_camera_range*sin(deg2rad(yaw));
  look_from_rad.z -= radar_camera_range*cos(deg2rad(yaw));
  look_from_rad.y = 200 + (get_translation().y)
  radar_camera.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))
  radar_camera2.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))


func radarzoom(target, remember=true):
  target_zoom = zoom_levels[target]
  if remember:
    last_zoom = target_zoom


func radarzoom_restore():
  target_zoom = last_zoom


func update_zoom(delta):
  if current_zoom == target_zoom:
    return
  var spd
  if current_zoom > target_zoom:
    spd = 25
  else:
    spd = 25
  current_zoom = lerp(current_zoom, target_zoom, spd*delta)
  radar_camera.set_orthogonal(current_zoom,1,800)
  radar_camera2.set_orthogonal(current_zoom,1,800)


func movement_input(ie):
#  if Input.is_action_pressed("kb_step_motion"):
#    kb_move = false
  if (Input.get_mouse_mode() != Input.MOUSE_MODE_CAPTURED):
    return;
#  var c_h_sz = ui_crosshair_tex.get_size().x / 2
  if (ie.type == InputEvent.MOUSE_MOTION):
    kb_move = false
    ui_crosshair_tex.show()
    if gsvar.config.confine_mouse:
      stick_x += ie.relative_x;
      stick_x = min(max(stick_x, -motion_bounds), motion_bounds);
      stick_y -= ie.relative_y;
      stick_y = min(max(stick_y, -motion_bounds), motion_bounds);
      ui_crosshair_tex.set_pos(Vector2(stick_x - c_h_sz, -stick_y - c_h_sz ));
    else:
      var wsize = OS.get_window_size()
      curs_posx = clamp(curs_posx + ie.relative_x, -wsize.x/2.0, wsize.x/2.0)
      curs_posy = clamp(curs_posy - ie.relative_y, -wsize.y/2.0, wsize.y/2.0)
      stick_x = clamp(curs_posx, -motion_bounds, motion_bounds)
      stick_y = clamp(curs_posy, -motion_bounds, motion_bounds)
      ui_crosshair_tex.set_pos(Vector2(curs_posx - c_h_sz, -curs_posy - c_h_sz));
  elif ie.type == InputEvent.KEY:
    var kb_actions = ["forward", "backward", "right", "left"]
    for i in kb_actions:
      if ie.is_action_released(i) and not Input.is_action_pressed("kb_step_motion"):
        if i in ["forward", "backward"]:
          stick_y = 0;
        if i in ["right", "left"]:
          stick_x = 0;
      if ie.is_action_released(i) or ie.is_action_pressed(i):
        kb_move = true
        break
    if Input.is_action_pressed("kb_step_motion"):
      ui_crosshair_tex.show()
      ui_crosshair_tex.set_pos(Vector2(stick_x - c_h_sz, -stick_y - c_h_sz))
    elif kb_move:
      ui_crosshair_tex.hide()


func kb_motion(delta):
  if not kb_enabled:
    return
  var step = 0
  var dt = delta * 1000
  var max_t = 70
  var max_x = motion_bounds - deadzone_bounds
  var a = max_x / pow(max_t,2)
  var dx = 2 * a * dt * sqrt(abs(stick_x)/a) + a * pow(dt,2)
  step = dx
#  var step_y = 20 * (motion_bounds - deadzone_bounds)  / 100.0
  var step_y = 40 * (motion_bounds - deadzone_bounds)  / 100.0
#  if abs(stick_y) < deadzone_bounds:
#    stick_y = deadzone_bounds * sign(stick_y)
  if abs(stick_y) < deadzone_bounds + (motion_bounds - deadzone_bounds) * 22 / 100:
#    step_y = 10
    step_y = 40
  if Input.is_action_pressed("kb_step_motion"):
    step_y = 6
    step = 4
  if Input.is_action_pressed("forward"):
    stick_y += step_y;
  if Input.is_action_pressed("backward"):
    stick_y -= step_y
#  if abs(stick_x) < deadzone_bounds:
#    stick_x = deadzone_bounds * sign(stick_x)
  if Input.is_action_pressed("right"):
    stick_x += step
  if Input.is_action_pressed("left"):
    stick_x -= step
  stick_x = clamp(stick_x, -motion_bounds, motion_bounds)
  stick_y = clamp(stick_y, -motion_bounds, motion_bounds)
  ui_crosshair_tex.set_pos(Vector2(stick_x - c_h_sz, -stick_y - c_h_sz))

func _fixed_process(delta):
  if paused:
    return
#  var vp = get_node("/root/world/radarframe/Viewport");
#  var render = vp.get_render_target_texture();
  #get_node("/root/world/radarframe_map").set_texture(render);
  g.report("delta", [delta], 1 , 1000, {"only":false})
  predict_position()
#  if gsvar.focus[-1] == "game" and kb_move:
  if gsvar.active_focus == "GC":
    if kb_move:
  #    g.report("kb move", [], 0 , 1000, {"only":false})
      kb_motion(delta)
    if Input.is_action_pressed('repeat_shoot'):
      shoot_think();
  if predict_landing_next_sync:
#    predict_landing()
    predict_landing_next_sync = false
  body.set_rotation(Vector3(0,body_rotation,0))
  update_radar(delta)
  update_zoom(delta)


func _process(delta):
  if paused:
    return
  if is_node_master:
    update_camera(delta)
#  predict_position()
  update_gui();
  update_elevation()
  update_ammo()
  dying_think();
  update_target(gsvar.player_by_id(ball.owner))
#  if g.time_since(self, 'last_trace', 300, true):
#    create_tank_trace()
  if g.time_since(self, 'last_ping',5000, true):
    net.ping_all()


func update_ammo(fire=false):
  .update_ammo()
  if fire:
    ui_ammo.set_text(str(shots_limit - ammo.size()) + "/" + str(shots_limit))
#  g.report("player", [], 0 , 1000, {"only":false})
  if (not ammo.empty() and g.rticks() - ammo[0].time > reload_time * 1000):
    ammo.pop_front()
    ui_ammo.set_text(str(shots_limit - ammo.size()) + "/" + str(shots_limit))
#func local_input():
#  if (!is_node_master):
#    return;
  #local_input[0] = force_jump or (gsvar.focus[-1] == "game" and Input.is_action_pressed("jump"))
##  camera_aim = Vector3(sin(body_rotation),0,cos(body_rotation))


#func update_elevation():
#  var lv = get_linear_velocity()
#  if not g.is_null(gsvar.me):
    #if lv.y != 0 or gsvar.me.current_zoom != gsvar.me.target_zoom :
      #var sc = sqrt(abs(get_translation().y)) / 3.5 * (pow(gsvar.me.current_zoom, 0.8) / 100.0)
      #get_node("body/radar_elevation").set_scale(Vector3(sc,1,sc));
      #var shd = get_node("/root/world/env/mapcontainer/Spatial/BZBox56").get_mesh().surface_get_material(0)
      #shd.set_shader_param( "elevation" , get_translation().y )
#      elevation = get_translation().y


func update_gui():
  if not is_node_master:
    return
  var aimtex = ui_crosshair3.get_node("tex2")
  var touching = not col_groups[0]["StaticBody"].empty()
  if not phys.resting:
    var rot = body_rotation
    var spd_corr = Vector2(cur_vel.x,cur_vel.z)
    var xt = -spd_corr.length() * sin(Vector2(sin(rot),cos(rot)).angle_to(spd_corr)) * (motion_bounds - deadzone_bounds) / 80.0
    g.report("xt", [xt],5, 100)
    aim_x = xt;
  else:
    aim_x = lerp(aim_x, 0, 0.3);
  g.report("aim_x", [aim_x, 'floor', phys.resting, 'touching', touching],5 , 1000)
  aimtex.set_pos(Vector2(aim_x,0))
  if aimtex.get_size().x > 48:
    g.report("crosshair size changed!", [aimtex.get_size()],1,1000)
    aimtex.set_size(Vector2(48,48))
  if (!is_node_master):
    return;
  ui_elevation.set_text(str(floor(get_translation().y * 100) / 100.0))
  ui_fps.set_text(str(OS.get_frames_per_second()))
  ui_health.set_text(str(int(health)).pad_zeros(3));
  if (is_aiming && !ui_crosshair3.is_visible()):
    ui_crosshair3.show();
  if (!is_aiming && ui_crosshair3.is_visible()):
    ui_crosshair3.hide();


func update_camera(delta):
  var pr = 0.0;
  var r = dist * 0.01;
  var tankeye = follow_player.get_node("body/shoot_pos").get_global_transform().origin;
  var y = tankeye.y + top_cam_elevation
  if (is_aiming):
    r = 3.2
    pr = 0
    y = tankeye.y
  tankeye.y = tankeye.y
  camera_range = lerp(camera_range, r, 20*delta);
  var look_from = tankeye;
  look_from.x -= camera_range*sin(deg2rad(yaw));
  look_from.z -= camera_range*cos(deg2rad(yaw));
  look_from.y = y;
#  camera_instance.look_at_from_pos(look_from, tankeye, Vector3(0,1,0));
  active_camera_instance.look_at_from_pos(look_from, tankeye, Vector3(0,1,0));
  if force_pause:
    get_tree().set_pause(true)

#
#func update_radar(delta):
#  if not is_node_master:
#    return
#  var vp = get_node("/root/world/radarframe/Viewport");
#  var render = vp.get_render_target_texture();
  #get_node("/root/world/radarframe_map").set_texture(render);
  #var r_pos = radar_camera.unproject_position(get_global_transform().origin)
#  r_pos.x -= (radar_player.get_size().x / 2.0 + 0.5)
#  r_pos.y -= (radar_player.get_size().y / 2.0 - 1)
#  radar_player.set_pos(r_pos)
  #var tankeye = get_node("body/shoot_pos").get_global_transform().origin;
#  var look_from_rad = tankeye;
  #if phys.above_pyra or (phys.on_pyra and not phys.on_floor):
#    radarzoom("close", false)
#  elif check_close_bullet():
#    radarzoom("dodge", false)
#  else:
#    radarzoom_restore()
  #if radar3d == false or  phys.above_pyra or (phys.on_pyra and not phys.on_floor) or check_close_bullet() :
    #radar_camera_range = lerp(radar_camera_range, 3, 20*delta);
#  else:
    #radar_camera_range = lerp(radar_camera_range, 100, 20*delta);
#  look_from_rad.x -= radar_camera_range*sin(deg2rad(yaw));
#  look_from_rad.z -= radar_camera_range*cos(deg2rad(yaw));
#  look_from_rad.y = 200 + (get_translation().y)
  #radar_camera.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))
  #radar_camera2.look_at_from_pos(look_from_rad, tankeye, Vector3(0,1,0))


func _integrate_forces(state):
  if paused:
    return

  g.report("__PHYS__", [phys], 1 , 1000, {"only":false})
  g.report("delta", [state.get_step()], 1 , 1000, {"only":false})
  if net.replay_state == net.REPLAY_PLAYING:
    replay_movement(state)
  elif (is_node_master or is_bot):
    if not new_spawn.empty():
      var t = Transform(Matrix3(), new_spawn.pos)
      state.set_transform(t)
      body_rotation = new_spawn.rot
      yaw = rad2deg(new_spawn.rot)
      request_sync([9, "new_pos"])
      new_spawn = []
    else:
      master_movement(state)
  else:
    slave_movement(state)
  cur_vel = state.get_linear_velocity()

#func replay_movement(state):
##  g.report("replay debug", [sm, sup], 0 , 1000, {"only":false})
#  slave_movement(state)
#  return
##  return
#  s_state['sp'] = sm[0] / 10000.0
#  s_state['tp'] = sm[1] / 10000.0
#  for i in sup:
#    s_state[i] = sup[i]
#  sup = {}
#  if phys.on_pyra:
#    s_state["sp"] = 0.0
#  speed_percent = s_state["sp"]
#  turning_percent = s_state["tp"]
#  real_movement(state);
#
#func master_movement(state):
#  local_input()
#  update_turning_percent()
#  update_speed_percent()
#  real_movement(state);

func mod_input():
  speed_modifier = 1.0
  if phys.resting:
    if Input.is_action_pressed("slowmo"):
      speed_modifier *= 0.15
    if Input.is_action_pressed("slowmo2"):
      speed_modifier *= 0.50
#  else:
#    speed_modifier = 1.0
#  if Input.is_action_pressed("slowmo") and phys.resting:
#    speed_modifier = 0.33
#  else:
#    speed_modifier = 1.0
  if (!is_node_master):
    return;
  local_input[0] = force_jump or (gsvar.focus[-1] == "game" and Input.is_action_pressed("jump"))

func slave_movement(state):
  if predict_landing_next_sync and synced:
    predict_landing()
    predict_landing_next_sync = false
  synced = false
  local_input[0] = false
  var syncing = false
  if sm[0] == null:
    g.report("faulty sm", [sm, sup], 0 , 100, {"only":false})
  s_state['sp'] = sm[0] / 10000.0
  s_state['tp'] = sm[1] / 10000.0
  for i in sup:
    s_state[i] = sup[i]
  if sup.has("st"):
    syncing = true
    var player_sync = net.sync_table[int(get_name())]
    var diff
    if player_sync.has("latency"):
      diff = OS.get_ticks_msec() - player_sync["rel_ticks"] - sup["st"] - player_sync["latency"]
      if net.is_primary:
        diff -= (net.server_simulation_delay - 2 * player_sync["latency"])
    else:
      global.report(["missing latency", int(get_name())] , [player_sync], 1000, 0, {"only":false})
      diff = 0
    predict_landing_next_sync = s_state["j"]
    if abs(diff)  > 50:
      g.chreport("ping sync out", [get_name(),diff], 0 , 1000, {"only":false})
#      global.report(["ping out of sync", get_name()], ["diff equals: ", diff], 0, 2000 )
      net.ping(int(get_name()))
  sup = {}
  if phys.on_pyra:
    s_state["sp"] = 0.0
  speed_percent = s_state["sp"]
  turning_percent = s_state["tp"]
  if syncing:
    var transform = state.get_transform();
#   transform.origin = transform.origin.linear_interpolate(s_state["p"], 10*state.get_step())
    transform.origin = s_state["p"]
    state.set_transform(transform);
    state.set_linear_velocity(s_state["lv"])
    yaw = rad2deg(s_state["r"])
    s_state["p"] = Vector3()
    s_state["lv"] = Vector3()
    s_state["r"] = 0.0
    synced = true
  else:
    real_movement(state);


#func replay_record():
#  var replay_recording = true
  #var rec_cur = [[get_transform() , get_linear_velocity(), _phys, turning_percent, speed_percent]]
#
#
#func replay_stop_rec():
#  var replay_recording = false
#
#
#func replay_play():
#  var init_replay = true



func predict_position(t=0.5):
  if is_node_master or gsvar.sv_dedicated:
    return
  var l = g.deep(net.sync_table, [int(get_name()), "latency"]) * 2
  if g.is_null(l):
    return
  t = l / 1000.0
  var yplus = 0.7
  var lv = get_linear_velocity()
  var fpos = Vector3()
  var pos = get_translation()
  if phys["on_floor"]:
    fpos = pos + lv * t
    fpos.y = fpos.y + yplus
  elif not phys["resting"]:
    fpos.x = pos.x + lv.x * t
    fpos.z = pos.z + lv.z * t
    fpos.y = yplus + pos.y + lv.y * t + (-9.8 * t)
  else:
    fpos = pos
    fpos.y = fpos.y + yplus
#    lagmate_pos = fpos
  var cam = get_viewport().get_camera()
  var pos1 = cam.unproject_position(pos);
  var pos2
  if freeze_lagmate:
    pos2 = cam.unproject_position(lagmate_pos);
  else:
    pos2 = cam.unproject_position(fpos);
    lagmate_pos = fpos
  var d3d = (gsvar.me.get_translation() - pos).length()
  var d2d = (pos2 - pos1).length()
  if  d2d < 20 or cam.is_position_behind(pos):
    get_node("lag_mate").hide()
    g.report("hide lag mate", [get_name(),d2d,d3d], 1 , 1000, {"only":false})
    return
  else:
    get_node("lag_mate").show()
    get_node("lag_mate").set_scale(Vector2(20.0/d3d, 20.0/d3d))
    g.report("show lag mate", [get_name(),d2d,d3d], 1 , 1000, {"only":false})

  get_node("lag_mate").set_pos(Vector2(pos2.x, pos2.y - 5))
  var rot = -(pos2 - pos1).angle_to(Vector2(1,0))
  get_node("lag_mate").set_rot(rot)
  get_node("projected_pos").set_translation(fpos - pos)
  g.report("projected pos", [pos,fpos, t], 1 , 5000, {"only":false})
  return fpos


func create_tank_trace():
  var dir = get_linear_velocity()
  if dir.length() < 0.01:
    return
  var inst = tank_trace_scene.instance()
  inst.set_name("ttrace");
  inst.set_global_transform(Transform(Matrix3(), get_translation()));
  gsvar.world.env.add_child(inst, true);
  inst.get_node("arrow").set_scale(Vector3(1.0,1.0* pow(dir.length()/25.0, 0.4),1.0) )
  if dir.length() == abs(dir.y):
#    g.report("vertical", [], 0 , 1000, {"only":true})
    inst.set_rotation(Vector3(sign(dir.y) * PI/2,0,0))
    return
  inst.look_at(get_translation() + 10*dir, Vector3(0,1,0))


#func set_request_sync():
#  request_sync = true


## predict where tank will land after jumping
func create_jump_trajectory_shapes():
  var shape
  for i in range(1,7,1):
    shape = ConcavePolygonShape.new()
    shape.set_faces(create_base_trajectory(i))
    trajectory_shapes.append(shape)


func create_base_trajectory(t):
  var z
  var y
  var traj=[]
  for i in range(0, (t+1)*10, 1):
    var j = i/10.0
    z = max_speed * j
    y = jump_velocity * j + (-world_gravity * j * j / 2)
    y += 1
    traj.append(Vector3(0,y,z))
    if i > t*10 - 1 :
      break
    if i != 0 and i%2 == 0:
      traj.append(Vector3(0,y,z))
  traj.invert()
  return Vector3Array(traj)


func predict_landing(test=0):
  for m in landing_marks:
    m.queue_free()
    landing_marks.clear()
  var psq_res
  var ri
  for shape in trajectory_shapes:
    setup_psq(shape, true)
    ri = get_world().get_direct_space_state().get_rest_info(psq)
    if not ri.empty():
      var lm = create_landing_mark(ri["point"], shape)
      landing_marks.append(lm)
      break


func setup_psq(shape, include_touching=true):
  psq = PhysicsShapeQueryParameters.new()
  psq.set_shape(shape)
  psq.set_object_type_mask( 1 )
  psq.set_margin(0.9)
  if not include_touching:
    psq.set_exclude(last_touching + touching_bodies['bottom'])
  var t = psq.get_transform()
  var rot = g.vec3rot(get_linear_velocity().normalized())
  t = t.rotated(Vector3(0,1,0), -rot).scaled(Vector3(1,1,abs(speed_percent) * 1))
  t.origin = get_transform().origin
  psq.set_transform(t)


func create_landing_mark(pos, shape):
  var inst = landing_mark_scene.instance();
  inst.set_name("expl");
  inst.set_global_transform(Transform(Matrix3(), pos));
  var ig = create_trajectory_ig(shape)
  inst.add_child(ig)
  ig.set_translation(get_translation() - inst.get_translation())
  gsvar.world.env.add_child(inst, true);
  return inst


func create_trajectory_ig(shape):
  var ig = ImmediateGeometry.new()
  var verts = shape.get_faces()
#  ig.set_material_override(trajectory_mat)
  ig.begin(VS.PRIMITIVE_LINE_LOOP  ,null)
  for v in g.array_range(verts,1,-1):
    ig.set_color(Color(1,0,0))
    ig.add_vertex(v)
  ig.end()
  var t = ig.get_transform()
#  t = t.rotated(Vector3(0,1,0), -body_rotation).scaled(Vector3(1,1,speed_percent * 1))
  var rot = g.vec3rot(get_linear_velocity().normalized())
#  if speed_percent < 0:
#    rot = 2*PI - rot
  g.report("rot vs lin vel", [g.abs_angle(body_rotation), g.abs_angle(rot)], 0 , 1000, {"only":false})
  t = t.rotated(Vector3(0,1,0), -rot).scaled(Vector3(1,1, abs(speed_percent)))
  ig.set_global_transform(t)
  return ig


func calc_move(state):
  var s = build_situation(state.get_step())
  situation = s
#  return
  if g.is_null(action_manager) or g.is_null(action_manager.current):
    return
  rel_enemy_motion.pop_front()
  rel_enemy_motion.append(s)
  action_manager.select_action(s)
#  var action = action_manager.actions[action_manager.current]
  g.scrn_dbg("action", action_manager.current)
  var action = action_manager.current_action()
  instr_speed(action.speed)
  instr_turn(action.turn)
  g.scrn_dbg("avg_stickx", g.avgr("stick_x", stick_x))
  if action.fire:
    g.report("move fire", [], 0 , -1, {"only":false})
    action_fire(action, {"s":s})

func action_fire(action, meta):
    g.report("action_fore", [], 0 , -1, {"only":false})

    var canshoot = can_shoot()
    if canshoot:
#      shoot_think({"s":s})
      shoot_think(meta)
#      g.scrn_dbg("last shot s", s)
#    shoot_think({"s":s})
    action.fired(canshoot)

func build_situation(delta=1.0/OS.get_iterations_per_second()): # setup ,establish - setting, context, case
  var s = {"P":{}, "B":{}}
  s["time"]      = OS.get_ticks_msec()
  s.B["inst"] = self
  s.B["pos"]  = get_translation()
  s.B["pos2"]  = g.xz(get_translation())
  s.B["rot"]  = g.uniform_angle(body_rotation)
  s.B["dir"] = Vector3(sin(s.B.rot),0,cos(s.B.rot))
  s.B["dir2"] = Vector2(sin(s.B.rot),cos(s.B.rot))
  s.B["vel"] = get_linear_velocity()
  s.B["vel2"] = g.xz(get_linear_velocity())
  s.B["heading"] = sign(s.B.vel2.dot(s.B.dir2))
#  var p_b = xz(s["B"]["pos"] - s["P"]["pos"])

  s.B["shots"] = ammo.size()

  var p = gsvar.me
  p = target_player
#  surr
  if not g.is_null(p):
    s.P["active"] = (gsvar.active_focus == "GC")
    s.P["inst"] = p
    s.P["pos"]  = p.get_translation()
    s.P["pos2"]  = g.xz(p.get_translation())
    s.P["rot"]  = g.uniform_angle(p.body_rotation)
    s.P["time"] = g.t()
    if situation_buffer.size() > 0:
      s.P["avel"] = (s.P.rot - situation_buffer[0].rot) * 1000 / (s.P.time - situation_buffer[0].time)
      s.P.avel = g.ftrunc(s.P.avel,2)
    else:
      s.P["avel"] = 0
    g.chreport("avel situ", [s.P.avel], 1 , 1000, {"only":true})
    s.P["vel"] = p.get_linear_velocity()
    s.P["vel2"] = g.xz(p.get_linear_velocity())
    s.P["dir"] = Vector3(sin(s.P.rot),0,cos(s.P.rot))
    s.P["dir2"] = Vector2(sin(s.P.rot),cos(s.P.rot))
    s.P["heading"] = sign(s.P.vel2.dot(s.P.dir2))
    s.P["shots"] = s.P.inst.ammo.size()
    # save P in buffer
    situation_buffer.append(g.copyvar(s.P))
    if situation_buffer.size() > 2:
      situation_buffer.pop_front()
    s.P = situation_buffer[0]
    s.P["inst"] = p

  #  s["face_ang"]       = g.abs_angle(-s.B2P.angle_to(Vector2(0,-1)))
  #  s["BProt"]       = g.uniform_angle(-s.B2P.angle_to(Vector2(0,1)))
    s["B2P"]       = g.xz(s.P.pos - s.B.pos)
    s["BProt"]       = g.vec2rot(s.B2P)
  #  s["P"]["ang"]  = min(abs(s.P.rot - s.face_ang), abs(2*PI - abs(s.P.rot-s.face_ang) ))
    s.P["ang"]  = g.uniform_angle(s.P.rot, s.BProt+PI)
    s.P["absang"]  = abs(g.uniform_angle(s.P.rot, s.BProt+PI))
    s.B["ang"]  = g.uniform_angle(s.B.rot, s.BProt)
    s.B["absang"]  = abs(g.uniform_angle(s.B.rot, s.BProt))
    s.P["side"] = -sign(s.B.ang)

  #  s["P"]["ang"] = min(abs(s.P.rot - s.face_ang), fmod(s.P.rot-s.face_ang, 2*PI ))
  #  s["rot_d"]     = min(abs(s.B.rot - s.P.rot), abs(abs(s.B.rot - s.P.rot) - PI))
  #  s["rot_d"]     = fmod(g.abs_angle(abs(s.B.rot - s.P.rot)), PI)
    s["ang_diff"]  = abs(s.B.ang) - abs(s.P.ang)
    s["dist"]      = s["B2P"].length()
  return s

func update_target(player):
  target_player = player
  stopped = g.is_null(target_player)

func instr_speed(fraction):
  stick_y = g.f2stick(fraction)


func instr_turn(fraction):
  stick_x = g.f2stick(fraction)


func master_movement(state):
  if g.time_since(self,"last_calc_move", 300):
    calc_move(state)
  update_turning_percent()
  update_speed_percent()
  real_movement(state);