extends "res://scripts/tank.gd"

# last_lv, local_input, speed_percent force_jump body_rotation on_floor moving jumping yaw stick_x stick_y curs_posx  curs_posy turning_percent frozen_turn
var _ph = {}
var ray_res = {}
var stopped = false
var rel_enemy_motion = [null,null,null]
var close_bullet = []
var instructions = []
var instructions_visualize = false
var instructions_fake = false
var instructions_start = false
var wait_instruction_running = false
var instructions_last_dest = [Vector3(), 0]
var instructions_fake_elapsed_time = 0
var bot_reset_position = Vector3()
var has_control = false
var event_delays = {}
var situation_buffer = []
var projected_marks = []
var target_player
var move_cur = "mov_default"
var move_map = {}
var move_map2 = {}
var action_manager
var situation
#onready var ball = get_node("/root/world/env/Ball")
#var records = {}

func _init():
#  shots_limit = 10
  is_bot = true
  event_times = {"last_reverse":0,"last_reverse_x":0, "last_evade_align":0, "last_escape_align":0, "last_evade_kill_intent":0, "last_chasing":0, "last_shoot":OS.get_ticks_msec() + 5000, "last_vary":0, "wait_instruction":0, "last_p_moving":0, 'last_calc_move':0, "last_jump":0}
  event_delays = {"last_shoot":150}

func _ready():
#  ._ready()
#  target_player = gsvar.me
  update_target(null)
  setup_move_map()
  g.store_set("scrn_dbg", {})

  player_name = "bot#" + str(pid)
#  get_node("/root/world/gui/objectsname").add_object(self)
  set_process(true);
  set_fixed_process(true);

func update_target(player):
  if player == target_player:
    return false
  g.report("new target", [player], 0 , -1, {"only":false})
  target_player = player
  stopped = g.is_null(target_player)
  return true

func _process(delta):
#  g.report("scrn_dbg", g.store_get("scrn_dbg"), 0 , 200, {"only":false, "out_mode":"screen"})
  g.store_set(["tank_info_extra", pid], {})
  update_ammo()
##  var target_change = update_target(gsvar.player_by_id(ball.owner))
#  var target_change = update_target(gsvar.me)
#  var s = build_situation()
#  situation = s
#
#  if target_change or time_since("last_calc_move", 370, true):
#
#    action_manager.select_action(situation)
  g.store_get(["tank_info_extra", pid],{})["action"] = action_manager.current
#  dying_think();


func update_ammo(fire=false):
#  if (not ammo.empty() and OS.get_ticks_msec() - ammo[0].time > reload_time * 1000):
  if (not ammo.empty() and g.rticks() - ammo[0].time > reload_time * 1000):
    ammo.pop_front()


func xz(v3):
  return Vector2(v3.x, v3.z)


func check_close_bullet():
  var spsq = setup_shot_col_psq()
  var ri = get_world().get_direct_space_state().get_rest_info(spsq)
  if not ri.empty() and (ri["point"] - get_translation()).dot(ri["linear_velocity"]) < 0:
    var ang_perc = (ri["point"] - get_translation()).angle_to(ri["linear_velocity"]) / PI
    if ang_perc > 0.9:
      last_close_shot_time = OS.get_ticks_msec()
      close_bullet = ri
      return true
  close_bullet = []
  return false


# return value {colliding:bool,parallel:bool, crossing:bool, ta:int, tb:int, point:v2|null}
func check_colliding(a,b,av,bv, t=0.5):
  var r = {"colliding":false,"parallel":false, "crossing":false, "ta":0, "tb":0, "point":null}
  var A1 = av.y
  var B1 = - av.x
  var C1 = A1*a.x+B1*a.y
  var A2 = bv.y
  var B2 = - bv.x
  var C2 = A2*b.x+B2*b.y
  var det = A1*B2 - A2*B1
  var x
  var y
  if det == 0:
    r.parallel = true
    if abs(abs(((b.x - a.x) / bv.x) / ((b.y - a.y) / bv.y)) - 1) < 0.2:
      g.report("parallel", [a,b,bv], 0 , 1000, {"only":false})
      r.colliding = true
      r.point = a
      r.tb = r.point.distance_to(b) / bv.length()
      r.ta = r.tb
#      return true
  else:
    r.crossing = true
    x = (B2*C1 - B1*C2)/det
    y = (A1*C2 - A2*C1)/det
    r.point = Vector2(x,y)
    r.ta = -1 * sign((a-r.point).dot(av)) * r.point.distance_to(a) / av.length()
    r.tb = r.point.distance_to(b) / bv.length()
#    if abs(ta - tb) < 1 or p.distance_to(a) < 2:
    if abs(r.ta - r.tb) < t:
      r.colliding = true
#      g.report("colliding trajectories", [x,y, r.ta,r.tb], 0 , 1000, {"only":true})
#      return true
#    return [x,y]
  return r
#  return false






func check_bullet_collision():
  var cb = close_bullet
  var a = xz(get_translation())
  var b = xz(cb.point)
  var av = xz(get_linear_velocity())
  var bv = xz(cb.linear_velocity)
#  g.report("a b av bv", [a,b,av,bv], 0 , 1000, {"only":true})
  return check_colliding(a,b,av,bv).colliding


func time_since(event, t=-1, update=false):
  if t == -1:
    t = event_delays[event]
  var times = event_times
  if OS.get_ticks_msec() - times[event] > t:
#    g.report("trigger event", [event, t, times[event],OS.get_ticks_msec()], 0 , 0, {"only":true})
    if update:
      times[event] = OS.get_ticks_msec()
#      time_since_up(event)
#      event_times[event] = OS.get_ticks_msec()
    return true
  return false


func time_since_up(event):
  var times = event_times
  event_times[event] = OS.get_ticks_msec()


func rot2v2(rot):
  return Vector2(sin(rot), cos(rot))


func rel_change(prop, prop2=null):
  var cur = rel_enemy_motion[-1]
  var before = rel_enemy_motion[-2]
  if g.is_null(prop2):
    return cur[prop] - before[prop]
  else:
    if before[prop].has(prop2) and cur[prop].has(prop2):
      return cur[prop][prop2] - before[prop][prop2]
    else:
      return 0


func move_evade_align(s):
  if rel_change("P.ang") < 0 and s["P"]["ang"] < 1 :
#    g.report("br mr ang", [br,mr,ang], 0 , 1000, {"only":true})
    if (s["rot_d"] < 1) and time_since("last_evade_align", 700):
      time_since_up("last_evade_align")
#      g.report("evade aligned chase", [], 0 , 1000, {"only":true})
#      stick_x = sign(stick_x) * (90 + randi()%30)
      stick_x = sign(rel_change("B.rot")) * (90 + randi()%30)
      return true
#      stop()
#      stick_y = -stick_y
  return false


func move_avoid_bullet(s):
  var clb = check_close_bullet()
  if clb and check_bullet_collision() or phys.side_touching:
    stick_x = g.randsign(60 + randi() % 60 )
    stick_y = g.randsign(90 + randi()%30)
    return true
  return false


func move_evade_aim(s):
  if (abs(rel_change("P.rot")) > 0.004 and  s["P"]["ang"]< randf()/30)  and s["rot_d"] < 2 and time_since("last_reverse", 300):
    if randf() > 0.8:
      time_since_up("last_reverse")
#      g.report("reverse", [], 0 , 1000, {"only":true})
      stick_x = -stick_x
      stick_y = -stick_y
      return true
  return false


func move_escape_align(s):
  if not s["chasing"] and s["P"]["ang"] < 0.3 :
#    g.report("br mr ang", [br,mr,ang], 0 , 1000, {"only":true})
    if (s["rot_d"] < 0.3) and time_since("last_escape_align", 700):
      time_since_up("last_escape_align")
#      g.report("escape align", [], 0 , 1000, {"only":true})
#      stop()
      stick_y = -stick_y
      stick_x = g.randsign(100 + randi() % 20 )
      return true
  return false


func predict_collision():
#  if ray_res.empty():
#    var bullet = self
  ray_res = {}
  var pos = get("transform/translation")
  var target = pos + get_linear_velocity().normalized() * 100
  ray_res = get_world().get_direct_space_state().intersect_ray(pos, target, [], 2147483647, 1);


func move_random():
  stick_x = g.randsign(60 + randi() % 60)
  stick_y = g.randsign(60 + randi() % 60)


func move_vary():
  if time_since("last_vary", 5000, true):
    move_random()
    return true
  return false


func move_avoid_obstacles():
  predict_collision()
  if not ray_res.empty() and (abs(get_translation().distance_to(ray_res.position)) < 20):
    var ln = ray_res.normal
    var lp = ray_res.position
#    g.report("pos, ln, lp", [get("transform/translation"), ln, lp], 0 , 1000, {"only":true})
    move_random()
    return true
  return false


func move_evade_kill_intent(s):
  if rel_change("P.ang") < 0 and s["P"]["ang"] < 0.5 and rel_change("dist") < -1/120.0:
#    g.report("br mr ang", [br,mr,ang], 0 , 1000, {"only":true})
    if (s["rot_d"] < 1) and time_since("last_evade_kill_intent", 100):
      time_since_up("last_evade_kill_intent")
#      g.report("evade kill intent", [], 0 , 1000, {"only":true})
#      stick_x = sign(stick_x) * (90 + randi()%30)
      stick_x = sign(rel_change("B.rot")) * (90 + randi()%30)
      return true
  return false


func move_chase(s):
  if not s["chasing"] and time_since("last_chasing", 1000):
    if rel_change("P.ang") < 0 or time_since("last_chasing", 3000):
#      g.report("chase", [], 0 , 1000, {"only":true})
      time_since_up("last_chasing")
      stick_x = sign(rel_change("B.rot")) * (90 + randi()%30)
      stick_y = g.randsign(60 + randi() % 60)
      return true
  return false


func move_forward():
  stick_x = 0
  stick_y = 120


func move_backwards():
  stick_x = 0
  stick_y = -120


func move_stop():
  stick_x = 0
  stick_y = 0


func stop():
  stick_x = 0
  stick_y = 0
  stopped = true


func resume():
  stopped = false


func toggle():
  if stopped:
    resume()
  else:
    stop()


func stop_resume():
  if stopped:
    resume()
  else:
    stop()


func _fixed_process(delta):
  if has_control:
    kb_motion(delta)


func take_control(b):
  has_control = b


func kb_motion(delta):
  var step_y = 10
  var step_x = 10
  if Input.is_action_pressed("forward"):
    stick_y += step_y;
  if Input.is_action_pressed("backward"):
    stick_y -= step_y
#  if abs(stick_x) < deadzone_bounds:
#    stick_x = deadzone_bounds * sign(stick_x)
  if Input.is_action_pressed("right"):
    stick_x += step_x
  if Input.is_action_pressed("left"):
    stick_x -= step_x
  stick_x = clamp(stick_x, -motion_bounds, motion_bounds)
  stick_y = clamp(stick_y, -motion_bounds, motion_bounds)

#
#conditions: [
# property , func, params
#B.ang < 40
#P.ang > 60 #
#p max forward does not colide with bb #
#],
#func think_move(s):
#  for t in tactics:
#    for c in t.condtions:
#      self.call(c[1], s.get(c[0]), [c[2]])
#func build_ai_state():



func build_situation(delta=1.0/OS.get_iterations_per_second()): # setup ,establish - setting, context, case
  var s = {"P":{}, "B":{}}
  s["time"]      = OS.get_ticks_msec()
  s.B["inst"] = self
  s.B["pos"]  = get_translation()
  s.B["pos2"]  = xz(get_translation())
  s.B["rot"]  = g.uniform_angle(body_rotation)
  s.B["dir"] = Vector3(sin(s.B.rot),0,cos(s.B.rot))
  s.B["dir2"] = Vector2(sin(s.B.rot),cos(s.B.rot))
  s.B["vel"] = get_linear_velocity()
  s.B["vel2"] = xz(get_linear_velocity())
  s.B["heading"] = sign(s.B.vel2.dot(s.B.dir2))
#  var p_b = xz(s["B"]["pos"] - s["P"]["pos"])

  s.B["shots"] = ammo.size()

  var p = gsvar.me
  p = target_player
#  surr
  if not g.is_null(p):
    s.P["active"] = (gsvar.active_focus == "GC")
    s.P["inst"] = p
    s.P["pos"]  = p.get_translation()
    s.P["pos2"]  = xz(p.get_translation())
    s.P["rot"]  = g.uniform_angle(p.body_rotation)
    s.P["time"] = g.t()
    if situation_buffer.size() > 0:
      s.P["avel"] = (s.P.rot - situation_buffer[0].rot) * 1000 / (s.P.time - situation_buffer[0].time)
      s.P.avel = g.ftrunc(s.P.avel,2)
    else:
      s.P["avel"] = 0
    g.chreport("avel situ", [s.P.avel], 1 , 1000, {"only":true})
    s.P["vel"] = p.get_linear_velocity()
    s.P["vel2"] = xz(p.get_linear_velocity())
    s.P["dir"] = Vector3(sin(s.P.rot),0,cos(s.P.rot))
    s.P["dir2"] = Vector2(sin(s.P.rot),cos(s.P.rot))
    s.P["heading"] = sign(s.P.vel2.dot(s.P.dir2))
    s.P["shots"] = s.P.inst.ammo.size()
    # save P in buffer
    situation_buffer.append(g.copyvar(s.P))
    if situation_buffer.size() > 2:
      situation_buffer.pop_front()
    s.P = situation_buffer[0]
    s.P["inst"] = p

  #  s["face_ang"]       = g.abs_angle(-s.B2P.angle_to(Vector2(0,-1)))
  #  s["BProt"]       = g.uniform_angle(-s.B2P.angle_to(Vector2(0,1)))
    s["B2P"]       = xz(s.P.pos - s.B.pos)
    s["BProt"]       = g.vec2rot(s.B2P)
  #  s["P"]["ang"]  = min(abs(s.P.rot - s.face_ang), abs(2*PI - abs(s.P.rot-s.face_ang) ))
    s.P["ang"]  = g.uniform_angle(s.P.rot, s.BProt+PI)
    s.P["absang"]  = abs(g.uniform_angle(s.P.rot, s.BProt+PI))
    s.B["ang"]  = g.uniform_angle(s.B.rot, s.BProt)
    s.B["absang"]  = abs(g.uniform_angle(s.B.rot, s.BProt))
    s.P["side"] = -sign(s.B.ang)

  #  s["P"]["ang"] = min(abs(s.P.rot - s.face_ang), fmod(s.P.rot-s.face_ang, 2*PI ))
  #  s["rot_d"]     = min(abs(s.B.rot - s.P.rot), abs(abs(s.B.rot - s.P.rot) - PI))
  #  s["rot_d"]     = fmod(g.abs_angle(abs(s.B.rot - s.P.rot)), PI)
    s["ang_diff"]  = abs(s.B.ang) - abs(s.P.ang)
    s["dist"]      = s["B2P"].length()

#  s["facing"] = rot2v2(s["P"]["rot"]).dot(rot2v2(s["B"]["rot"])) < 0
#  s["chasing"]   = rot2v2(s.B.rot).dot(s.B2P.normalized()) > 0
#  s["chased"]    = rot2v2(s.P.rot).dot(-s.B2P.normalized()) > 0
#  situation_buffer.append(s.P)
#  if situation_buffer.size() > 20:
#    situation_buffer.pop_front()
#  var x = str2var( var2str( s ) )
#  x.P = situation_buffer[0]
#  g.chreport("xp eq sp", [x.P.vel2, s.P.vel2], 0 , 5000, {"only":true})
  return s


#func think_move(cur,s):
#  for m in cur:
#    if move_type(m) == "action":
#      m.perform()
#    elif move_type(m) == "container":
#      think_move(m,s)


func action_fire(action, meta):
    g.report("action_fore", [], 0 , -1, {"only":false})

    var canshoot = can_shoot()
    if canshoot:
#      shoot_think({"s":s})
      g.callv_later(self, 'shoot_think', args=[], 0.01)
#      shoot_think(meta)
#      g.scrn_dbg("last shot s", s)
#    shoot_think({"s":s})
    action.fired(canshoot)

func calc_move(state):

#    return
#  var s = build_situation(state.get_step())
#  situation = s
  if g.is_null(action_manager) or g.is_null(action_manager.current):
    return
  var s
  action_manager.cache.bs[pid] = situation

#  if time_since("last_calc_move", 10, true):
#    s = build_situation(state.get_step())
#    situation = s
##    action_manager.select_action(s)
#  else:
#    return

  s = situation
  rel_enemy_motion.pop_front()
  rel_enemy_motion.append(s)
  var action = action_manager.current_action()
  action.move(s)
  action.fire(s)
#  var action = action_manager.actions[action_manager.current]
  g.scrn_dbg("action/" + str(pid), action_manager.current)
  var action = action_manager.current_action()
  instr_speed(action.speed)
  instr_turn(action.turn)
  g.scrn_dbg("avg_stickx", g.avgr("stick_x", stick_x))
  if action.fire:
    g.report("move fire", [], 0 , -1, {"only":false})
    action_fire(action, {"s":s})
#    call_deferred("action_fire", [action, {"s":s}])
#    g.object_timer("action_fire", self, "action_fire", false , 0.1, [action, {"s":s}])
#    var canshoot = can_shoot()
#    if canshoot:
##      shoot_think({"s":s})
#      call_deferred("shoot_think", {"s":s})
##      g.scrn_dbg("last shot s", s)
##    shoot_think({"s":s})
#    action.fired(canshoot)
  return
  if g.is_null(target_player):
    move_guard(s)
    return
#  var s = {}
#  var cur = moves_root
#  var cur = {}
  move_instructions()
#  think_move(cur,s)
  rel_enemy_motion.pop_front()
  rel_enemy_motion.append(s)
#  g.report("P.rot, ang", [ s.P.rot,s.face_ang], 1 , 200, {"only":true})
#  g.report("P.ang", [ s.P.ang], 1 , 200, {"only":true})
#  g.report("chasing,chased", [s["chasing"], s["chased"]], 1 , 1000, {"only":true})
#  move_avoid_obstacles()
#  move_vary()
#  if s["chased"]:
#    move_chased(s)
  select_move(s)
  if true or s["chasing"]:
    var can_kill = check_can_kill(s)
#    return
    move_chasing(s)
#  move_chasing(s)


func move_chasing(s):
#  return

  var col_check = move_lock(s)

  move_close_in(s)
  move_guard(s)
#  move_stay_in_zone(s)
  move_shoot_if_aiming(s, col_check)
  if not s.P.active:
    instr_speed(0)
    instr_turn(0)
  return

func get_angle_to(pos, dir, dest):
  var p2d = dest - pos
  return g.uniform_angle(dir - g.vec3rot(p2d))

class PositionDefenceAction:
  func _init():
    pass

  func score(s):
    pass

  func should_fire(s):
    pass

  func should_move(s):
    pass

func setup_move_map():
  move_map2["attack"] = {
    "99default":{
      "good_trap":[90,100,120,null],
      "good_bang":[0.1,null,null,null],
      "lock_lead":[],
      "lock_point":[],
      "good_cross":[],
      "shoot_no_cross":[]
    }
  }
  move_map = {
    "lock":{"lead":{
      "mov_default":[0.6, 0.2, 0.0, 0.6],
      "trap2":[0.6, 0.0, -0.2, 0.6],
      },
      "point":{
        "forward_steep":[-5,0,5]
      }
    },
    "spread_lock":{"B.ang":{

      }
    },
    "shoot_cross": {
      "mov_default":[[-0.2715,0.671],[0.05,0.05],[-0.1,-0.05],[-0.05,0.05]],
      "trap2":[[-0.2715,0.671],[0.05,0.05],[-0.1,-0.0],[-0.05,0.05]],
    },
    "shoot_ncross": {
      "mov_default":[[-0.05,0.05],[-0.05,0.05],[-0.05,0.05],[-0.05,0.05]],
      "trap2":[[-0.05,0.05],[-0.01,0.01],[-0.05,0.05],[-0.05,0.05]],
    },

  }
func select_move(s):
  var moves = move_map2["attack"].keys()
  moves.sort()
  var move
  var good_trap
  var good_bang
  var move_data
  var ns = s.B.numshots
  for m in moves:
    move_data = move_map2.attack[m]
    good_trap = abs(s.dist * sin(s.P.ang)) < move_data.good_trap[ns]
    if m == "99default":

      move = m
      break
  if ns == 0:
    move_cur = "mov_default"
  elif ns == 1:
    # if P moves backwards activate trap2
    if s.P.heading != ammo[0].meta.s.P.heading:
      move_cur = "trap2"
  g.scrn_dbg("move_cur", move_cur)


func move_lock(s):
  var numshots = ammo.size()
#  var map = {
#    "trap1":{0:0.6, 1:0.0, 2:0.0},
#    "trap2":{0:0.6, 1:0.0, 2:0.0},
#  }
#  var map = {
#    "mov_default":[0.6, 0.2, 0.0, 0.6],
#    "trap2":[0.6, 0.0, 0.0, 0.6],
#  }
  var map = move_map.lock.lead

  var lead = map[move_cur][numshots]
  g.scrn_dbg("lock_lead", lead)
  var col_check = turn_to_shot_colliding(s, lead)
  return col_check

func move_stay_close_to(s, dest, max_dist, keep_orientation=true):
    var B2dest = (dest - s.B.pos)
    var dist = B2dest.length()
    if dist < max_dist:
      return
    var rot = s.B.rot
    var ang = g.uniform_angle(rot - g.vec3rot(B2dest))
    if abs(ang) > PI/2:
      instr_speed(-1)
    else:
      instr_speed(1)


func move_shoot(s,col):
  var shoot = check_shot_conditions(s,col,move_cur)


func check_shot_conditions(s,col,move):
  # t for test
  var t = {"good_trap":null, "good_cross":null}
  var numbul = ammo.size()
#  if g.test(move.good_trap[numbul])
  if g.deep_has(move, ["good_trap", numbul]):
    t.good_trap = abs(s.dist * sin(s.P.ang)) < move.good_trap[numbul]
    if not t.good_trap:
      return false
#  if col.crossing and g.test(move.good_cross[numbul])
  if col.crossing and g.deep_has(move, ["good_cross", numbul]):
    var cm = move.shoot_cross[numbul]
    t.good_cross = g.is_between(col.td, cm[0], cm[1])
    if not t.good_cross:
      return false



func move_shoot_if_aiming(s, col_check):
  return
  var goal_pos = Vector3(0,0,330)
  var p_goal_ang = get_angle_to(s.P.pos, s.P.rot, goal_pos)
  var p_goal_dist = (s.P.pos - goal_pos).length()
#  var crossing_map = {
#    "mov_default":[[-0.2715,0.671],[0.05,0.05],[-0.1,-0.05],[-0.05,0.05]],
#    "trap2":[[-0.2715,0.671],[0.05,0.05],[-0.1,-0.05],[-0.05,0.05]],
#  }
  if not col_check.crossing and s.P.heading == 10:
    col_check = new_check_colliding(s.B.pos2,s.P.pos2,s.B.dir2 * 100, -s.P.vel2, 0)
    g.scrn_dbg("newcolchk", col_check)

  g.scrn_dbg("sBang", [s.B.ang, g.is_between(s.B.ang, -0.05, 0.05), clamp(s.B.ang, -0.05, 0.05) ])
  g.scrn_dbg("crossing", col_check.crossing)
  g.scrn_dbg("time diff", col_check.td)
  g.scrn_dbg("ammo", ammo.size())
  g.scrn_dbg("ammo check", move_map.shoot_cross[move_cur][ammo.size()])
  g.scrn_dbg("heading", s.P.heading)
  var cm = move_map.shoot_cross[move_cur][ammo.size()]
  var good_trap = abs(s.dist * sin(s.P.ang)) < 85
  var great_trap = abs(s.dist * sin(s.P.ang)) < 70
  var spot_on = great_trap and s.B.ang < 0.01
  var good_cross = col_check.crossing and g.is_between(col_check.td, cm[0], cm[1])
#  var good_nc = not col_check.crossing and abs(s.B.ang) < 0.05 and ammo.size() < 1
  var ncm = move_map.shoot_ncross[move_cur][ammo.size()]
  var good_nc = great_trap and not col_check.crossing and g.is_between(s.B.ang, ncm[0], ncm[1]) and ammo.size() == 1

  var duplicate = ammo.size() > 0 and abs(ammo[-1].meta.s.B.rot - s.B.rot) < (0.06 * dist / 80.0)
  var too_late = (ammo.size() == 1 and time_since("last_shoot", 250))
  g.scrn_dbg("trap", abs(s.dist * sin(s.P.ang)))
  g.scrn_dbg("duplicate", duplicate)

  if s.P.inst.is_dying:
    ammo = []
  if s.P.inst.is_dying or  not s.P.active:
    return
#  if p_goal_dist < 250 && abs(p_goal_ang) < 1.2 && col_check.crossing and col_check.td < 0.2 and col_check.td > -0.3:
#  if p_goal_dist < 2500 && abs(p_goal_ang) < 4.2 && (good_cross or good_nc):
  if ammo.size() < 3 and (spot_on or not too_late) and not duplicate and good_trap and (good_nc or good_cross):
    if time_since("last_shoot", 100):
      var dbg_ = {"ammo":ammo.size(), "spot_on":spot_on, "too_late":too_late,  "great_trap":great_trap, "good_nc":good_nc, "good_cross":good_cross, "td":col_check.td, "sbang": s.B.ang, "time diff": col_check.td}
      g.report("shot debug", g.pretty_str(dbg_, 120), 0 , -1, {"only":false})
      g.scrn_dbg("last shot", dbg_)
#      g.chreport("here", [ammo.size(), s.B.ang, col_check.crossing ,col_check.td], 0 , -1, {"only":false})
      instr_speed(1.0)
      call_deferred("shoot_think", {"s":s})
#      g.scrn_dbg("last shot s", s)
#      var mid = shoot_think()
#      ammo[-1]["s"] = s
      time_since_up("last_shoot")

func check_abort(s):
  if check_idle(s):
    return true
  elif s.P.inst.is_dying:
    return true
  else:
    return false


func move_stay_in_zone(s):
  move_stay_close_to(s, Vector3(0,0,330), 50)
#  var B2basket = (Vector3(0,0,330) - s.B.pos)
#  var dist = B2basket.length()
#  if dist > 100:
#    instr_turn(-sign(g.vec3rot(B2basket)))
#    instr_speed(1)

func move_close_in(s):
  var too_far_range = s.B2P.length() > 150
  var far_range = s.B2P.length() > 100
  var close_range = s.B2P.length() < 70
  if too_far_range:
#    turn_to_shot_colliding(s, -0.3)
    instr_speed(1.0)
  if far_range:
#    turn_to_shot_colliding(s, -0.2)
    instr_speed(0.5)
  elif close_range:
#    turn_to_shot_colliding(s, -0.5)
    instr_speed(-1.0)
#    stick_x = -stick_x
  else:
    instr_speed(0)

func move_guard(s,guard_pos=Vector3(0,0,330)):
  var target_pos = guard_pos
  if s.P.has("pos"):
    target_pos = s.P.pos
  var target_dist = (target_pos - guard_pos).length()
  var middle_point = (target_pos - guard_pos) / 2.5 + guard_pos
  var mark = g.create_mark({ "pos":middle_point, "color":Color(1,1,0,0.2)}, "guard_point", true, false)
#  g.colorify_object(mark, Color(1,1,0,0.2))
  move_stay_close_to(s, middle_point , 50)


func new_check_colliding(a,b,av,bv, t, any_leading=false):
  var r = {"colliding":false,"straight":false, "crossing":false, "ta":null, "tb":null, "td":null, "point":null}
  if bv.length() < 3:
    "compare _a speed to ab vector"
    var avrot = g.vec2rot(av)
    var abrot = g.vec2rot(b-a)
    if abs(avrot - abrot) < 0.05:
      r.straight = true
      r.crossing = true
      r.colliding = true
      r.tb = (b-a).length() / av.length()
      r.ta = r.tb
      r.point = b
      r.td = 0
      return r
  if bv.length() < 20:
    bv = bv * 20/(bv.length()+1)
#    g.report("bvbvbv", [bv], 0 , 1000, {"only":true})
# if   g.report("label", [avrot -  abrot], 0 , 1000, {"only":true})
#  gen_expected_destinations(b, angle, 0.001, bv.length(), 2, 2)
  var length = 3.0

  g.create_mark({"update":true, "pos":g.v2tov3(a+av*length), "label":"A"}, "adest", true, false)
  g.create_mark({"update":true, "pos":g.v2tov3(b+bv*length), "label":"B"}, "bdest", true, false)
  var intersection = Geometry.segment_intersects_segment_2d( a, a+av*length, b, b+bv*length)
  if typeof(intersection) == TYPE_VECTOR2:

    r.crossing = true
    r.ta = (intersection - a).length() / av.length()
    r.tb = (intersection - b).length() / bv.length()
    r.td = r.ta - r.tb
    r.point = intersection
    if abs(r.ta - r.tb) < 0.1:
      r.colliding = true
#    if (abs(r.ta - r.tb) - abs(t)) < 0.1 and (any_leading or sign(r.ta - r.tb) == sign(t)):
#      r.colliding = true

  return r
#  if intersection == -1:

func turn_to_shot_colliding(s,lead=-0.2):
#  g.report("label", [s], 0 , 1000, {"only":false, "out_mode":"screen"})
#  lead = -0.0
  var col_check = new_check_colliding(s.B.pos2,s.P.pos2,s.B.dir2 * 100, s.P.vel2, lead)

  var speeding_side = sign(s.B.dir2.dot(s.P.vel2))
  speeding_side = -s.P.side
  var mark
  var color
  var label = ""
  if col_check.crossing:
    var cur_lead = col_check.ta - col_check.tb
    var mark_pos = g.v2tov3( col_check.point)
    if abs(cur_lead - lead) < 0.01:
      # we're good
#      instr_turn(0)
      color = Color(0,0,0,0.3)
      label = "GO"
      instr_turn(0.0)
    elif cur_lead - lead < 0:
      color = Color(1,1,1,0.3)
      label = "LE"
      instr_turn(speeding_side)
      # much lead
    else:
      color = Color(1,0,1,0.3)
      label = "LA"
      instr_turn(-speeding_side)
    # much lag
    mark = g.create_mark({"update":true, "arrow_rot":(speeding_side*PI/2)+s.B.rot, "pos":mark_pos, "color":color, "label":str([lead, speeding_side, label, g.avgr("stick_x", stick_x)])}, "lead", true, false)
  else:
    color = Color(1,1,1,0.8)
    label = "lost track"
    if abs(s.B.ang) < 0.1:
#      instr_turn(speeding_side)
      instr_turn(-s.P.side)
    else:
      instr_turn(-s.P.side)
#    mark = g.create_mark({"update":true, "arrow_rot":speeding_side*s.P.rot, "pos":s.P.pos, "color":color, "label":str([lead, speeding_side, label, g.avgr("stick_x", stick_x), stepify(s.B.ang, 0.01)])}, "lead", true, false)
    mark = g.create_mark({"update":true, "arrow_rot":(speeding_side*PI/2)+s.B.rot, "pos":s.B.pos, "color":color, "label":str([lead, speeding_side, label, g.avgr("stick_x", stick_x), stepify(s.B.ang, 0.01)])}, "lead", true, false)
  g.scrn_dbg("bot turning", g.avgr("stick_x", stick_x))
  g.scrn_dbg("angle_diff", s.ang_diff)

  return col_check

#
## distinguish between forward and backward motion
#func turn_to_shot_colliding(s,t=-0.2):
##  g.report("dir vs vel", [s.P.dir2.dot(s.P.vel2)], 0 , 1000, {"only":false})
#  var going_forward = s.P.dir2.dot(s.P.vel2) > 0
##  if !going_forward:
##    return
##  var shotvel =
##  var col_check = check_colliding(s.B.pos2,s.P.pos2,s.B.dir2 * 100, s.P.vel2, 0.01)
#  "if bullet arrives later than tank turn in direction of tank speed"
#  var col_check = new_check_colliding(s.B.pos2,s.P.pos2,s.B.dir2 * 100, s.P.vel2, t)
##  g.report("intersection check", [new_check], 0 , 1000, {"only":true})
#  if col_check.colliding:
#    instr_turn(0)
##    instr_turn(  -sign(col_check.ta - col_check.tb) * s.P.side)
#  elif col_check.crossing:
#    instr_turn(sign(col_check.td ) * s.P.side)
#  else:
#    instr_turn(-s.P.side)
##    if going_forward:
##      instr_turn(-s.P.side)
##    else:
##      instr_turn(-s.P.side/2.0)
#
##  if col_check.ta > col_check.tb:
##    instr_turn(s.P.side)
##  else:
##    instr_turn(-s.P.side)
##  g.report("col chk", [col_check], 0 , 1000, {"only":true})
#  return col_check
##  pass




func check_idle(s):
  if s.P.vel2.length() > 0:
    time_since_up("last_p_moving")
    return false
  if time_since("last_p_moving", 3000):
    return true
  else:
    return false


func calc_shot_lead(col_check):
  var shot_lead  = -sign(col_check.td )
  if abs(col_check.td ) < 0.1:
    shot_lead = 0
  elif abs(col_check.td ) < 0.2:
    shot_lead *= 1
  elif abs(col_check.td ) < 0.5:
    shot_lead *= 2
  elif abs(col_check.td ) < 1:
    shot_lead *= 3
  elif abs(col_check.td ) > 1:
    shot_lead *= 4
  return shot_lead


func move_chased(s):
  return
#  g.report("chased action", [], 1 , 2000, {"only":true})
#  move_forward()

#  move_avoid_bullet(s)
#  move_avoid_obstacles()
  (
  move_avoid_bullet(s) or
#  move_escape_align(s) or
#  move_evade_kill_intent(s) or
#  move_evade_aim(s) or
  move_chase(s) or
  false
#  move_dont_give_ass()
#  move_evade_align(s)
  )

func mark_projected_collision(pos):
  for m in projected_marks:
    m.queue_free()
    projected_marks.clear()
  var mark = create_mark(pos)
  projected_marks.append(mark)

func create_mark(pos):
  var inst = landing_mark_scene.instance();
  inst.set_name("expl");
  inst.set_global_transform(Transform(Matrix3(), pos));
  gsvar.world.env.add_child(inst, true);
  return inst


func check_can_kill(s):
  var numshots = 2
  var expdest = g.gen_expected_destinations(s.P.pos2, s.P.rot, g.f2av(-sign(s.P.avel)), 50,2, 1.0)
  var lines = []
  var curline = s.P.pos2
  for expd in expdest:
    lines.append([curline, g.xz(expd[0])])
    curline = expd[0]
  #g.chreport("exp dests", [lines], 0 , 10000, {"only":true})
#  draw_expected_path(duration/1000.0, "tank", {'maximize':true})


func move_lock_shoot(s):
  var col_check = turn_to_shot_colliding(s, -2)
  return col_check
  var c = {"ammo":ammo.size(), "ang_dist_value":null, "shot_lead":calc_shot_lead(col_check)} # c for checks
#  var good_shot
  var in_range = s.B2P.length() < 200
  c.ang_dist_value = abs(s.ang_diff) * pow(s.B2P.length(), 2)
  if check_abort(s):
    return
#  g.report("angdist", [ang_dist_value], 0 , 1000, {"only":true})
  if in_range:
#    return
    if c.ammo == 0 and c.ang_dist_value < 8000 and col_check.crossing:
      action_try_first_shot(s,c,col_check)
    if c.ammo == 1 and c.ang_dist_value < 3200:
      action_try_second_shot(s,c,col_check)
  #  if (c.ammo == 2 and c.ang_dist_value < 900):
    if (c.ang_dist_value < 900):
      action_try_sure_shot(s,c,col_check)


#    g.report("s angdeff", [s.ang_diff], 0 , 1000, {"only":true})

  return
#  if good_shot and in_range:
#    if time_since("last_shoot"):
#      event_delays["last_shoot"] =  500 + randi()%1000
#      shoot_think()
#      time_since_up("last_shoot")
#
##    g.report("in range", [], 0 , 1000, {"only":true})
#    pass

func action_try_first_shot(s,c,col_check):
  col_check = turn_to_shot_colliding(s, -0.2)
##    c["is_tiny_margin"] = abs(col_check.td) < 0.1
#    c.is_tiny_margin = false
#    c["tank_leads_by_medium_margin"] = (col_check.tb < col_check.ta) and abs(col_check.td ) > 0.2 and abs(col_check.td ) < 0.5

#    c.tank_leads_by_medium_margin = false
#    var good_shot = c.is_tiny_margin or c.tank_leads_by_medium_margin
  var good_shot = (g.is_between(c.shot_lead, -1 ,1)) and (col_check.point - s.P.pos2).length() < 10
  if good_shot:
#      if time_since("last_shoot", 300):
    mark_projected_collision(g.v2tov3(col_check.point))
    g.chreport("shot1", [c, col_check], 0 , 0, {"only":false})
    shoot_think()
    time_since_up("last_shoot")
    return true
  return false


func action_try_second_shot(s,c,col_check):
  c["close1st"] = not time_since("last_shoot", 600)
  var good_shot = (turn_to_shot_colliding(s, 0.4).colliding and c.close1st) or turn_to_shot_colliding(s, 0.1).colliding
  if good_shot:
    if time_since("last_shoot", 150):
      if not g.is_null(shoot_think()):
        time_since_up("last_shoot")
#          g.chreport("shot2", [c], 0 , 0, {"only":false})
        if c.close1st:
          g.chreport("shot2", [c], 0 , 0, {"only":false})

func action_try_sure_shot(s,c,col_check):
  c["recent_shot300"] = not time_since("last_shoot", 300)
  col_check = turn_to_shot_colliding(s, 0.1)
  var good_shot = col_check.colliding or (c.recent_shot300 and turn_to_shot_colliding(s, 0.2).colliding)
  if good_shot:
    if time_since("last_shoot", 150):
      if not g.is_null(shoot_think()):
        time_since_up("last_shoot")
        g.chreport("shot3", [c], 0 , 0, {"only":false})


func positioner(position_array):
  var pos = position_array[0]
  var rot = position_array[1]
  get_node("col_capsule").set_rotation(Vector3(0, float(rot),0));
#  var p = pos
  new_spawn = {"pos":pos, "rot":rot}


func instr_save_position():
  bot_reset_position = [get_translation(), body_rotation]
  instructions_last_dest = bot_reset_position

func instr_reset_position():
  positioner(bot_reset_position)
  instructions_last_dest = bot_reset_position
#  g.report("bot_reset_positionvar", [bot_reset_position], 0 , 1000, {"only":true})
func instr_wait(t):
  var done = false
  if not wait_instruction_running:
    time_since_up("wait_instruction")
    wait_instruction_running = true
  if time_since("wait_instruction", t):
    done = true
    wait_instruction_running = false
  return done


func instr_speed(fraction):
  stick_y = g.f2stick(fraction)


func instr_turn(fraction):
  stick_x = g.f2stick(fraction)


func set_instructions(instr,visualize=true, fake=true):
  instructions = instr
  instructions_visualize = visualize
  instructions_fake = fake
  instructions_start = OS.get_ticks_msec()



func draw_expected_path(duration, type="tank", opts={}):
  var default_opts = {'maximize':false,
 'reverse_x':false, 'reverse_y':false,'draw':true}
  opts = g.mergedicts(default_opts, opts)
  var types = ["tank", "shot"]
#  var position = xz(get_translation())
  var position = xz(instructions_last_dest[0])
#  var angle = body_rotation
  var angle = instructions_last_dest[1]
  var v = g.f2v(g.stick2f(stick_y))
  var av = g.f2av(g.stick2f(stick_x))
  if opts.maximize:
    v = g.f2v(sign(stick_y))
    av = g.f2av(sign(stick_x))
  if opts.reverse_x:
    av = - av
  if opts.reverse_y:
    v = - v

  var step = 0.2
  var time_elapsed = (OS.get_ticks_msec() - instructions_start) / 1000.0
  if instructions_fake:
    time_elapsed = instructions_fake_elapsed_time / 1000.0
    g.report("time time_elapsed fake", [time_elapsed], 0 , 0, {"only":false})
  if type == "shot":
    av = 0.001
    v = 100
    duration = 2
  var expected_path = g.gen_expected_destinations(position, angle, av, v, duration,step)
  if opts.draw:
    g.draw_destinations(
      expected_path , time_elapsed / step
    )
  return expected_path


func move_instructions():
  var viz = instructions_visualize
  if not instructions.empty():
    g.report("remaining bot instructions", instructions, 1 , 0, {"only":false, "changed":true})
    var cur = instructions[0]
    if cur[0] == "wait":
      if viz and not wait_instruction_running:
        var duration = cur[1]
        instructions_last_dest = draw_expected_path(duration/1000.0, "tank", {'maximize':true})[-1]
#        visualize_tank_path
      if instructions_fake:
        instructions_fake_elapsed_time += cur[1]
#        pass
      else:
        var done = instr_wait(cur[1])
        if not done:
  #        instructions.pop_front()
          return
        else:
          instructions_last_dest = [get_translation(), body_rotation]
#      if not wait_instruction_running:
#        time_since_up("wait_instruction")
#        wait_instruction_running = true
#      if not time_since("wait_instruction", cur[1]):
#        return
#      else:
#        wait_instruction_running = false
#        instructions.pop_front()
#        return
    elif cur[0] == "shoot":
      if viz:
        draw_expected_path(0,"shot")
#        pass
#        visualize_shot_path
      if not instructions_fake:
        shoot_think()
    elif cur[0] == "stop":
      stick_x = 0
      stick_y = 0
    elif cur[0] == "save":
      instr_save_position()
    elif cur[0] == "reset":
      instr_reset_position()
    elif cur[0] == "repeat":
      var endidx = instructions.find("end")
      var repeat_instructions = g.array_range(instructions, 1, endidx-2)
      g.report("find repeat instructions", [repeat_instructions], 0 , 0, {"only":false})
      for i in range(cur[1]-1):
        var x = 0
        for j in repeat_instructions:
          x += 1
          instructions.insert(x, j)
    elif cur[0] == "fn":
      callv(cur[1], g.array_range(cur, 2, -1))
    elif cur[0] == "speed":
      instr_speed(cur[1])
    elif cur[0] == "turn":
      instr_turn(cur[1])
    elif cur[0] == "set":
      set(cur[1], cur[2])
    elif inst2dict(self).has(cur[0]):
      set(cur[0], cur[1])
    else:
      g.report("unhandled instruction", [cur], 0 , 0, {"only":false})
    instructions.pop_front()
  else:
    instructions_fake = false
    instructions_visualize = false
    instructions_fake_elapsed_time = 0



func clear_recorded_positions(group):
  gsvar.clear_records(group)


func record_position(group):
  gsvar.add_record(group, [g.xz(get_translation()), body_rotation])

func move_aim(s):
  g.report("_phvar", [_ph], 1 , 0, {"only":false, "changed":true})
  if !_ph.has("aim_shots"):
    _ph["aim_shots"] = {}
  var aim_shots = {}
  for shot in ammo:
    aim_shots[shot.mid] = _ph["aim_shots"][shot.mid]
#  g.report("B.ang", [s.B.ang], 0 , 1000, {"only":true})
  if true or s["P"]["ang"] - s["B"]["ang"] > -0.3:
#    g.report("s.P.side", [s.P.side], 0 , 1000, {"only":true})
#    g.report("s.dist", [s.dist], 1 , 1000, {"only":true})
#    if s.B.ang > 0.01:
    if (s.dist < 60 and s.B.ang > 0.2) or (s.dist < 100 and s.B.ang > 0.25) or s.B.ang > 0.3 :
#      g.report("haa", [], 0 , 1000, {"only":true})
#      stick_x = 250 * sign(s.P.side)
      stick_x = g.f2stick(1) * sign(s.P.side)
      stick_y = 0
    if s.B.ang < 0.3:
      var a = xz(s.P.pos)
      var b = xz(s.B.pos)
#      var av = xz(gsvar.me.get_linear_velocity())
      var av = xz(gsvar.me.get_linear_velocity())
      if ammo.size() == 0:
        av = xz(gsvar.me.get_linear_velocity().normalized() * 25.0)
        if gsvar.me.stick_y < 0:
          av = av / 2.0
      var bv = xz(get_linear_velocity() + 100 *  Vector3(sin(s.B.rot),0,cos(s.B.rot)))
    #  g.report("a b av bv", [a,b,av,bv], 0 , 1000, {"only":true})
      var colchk = check_colliding(a,b,av,bv, 0.1)
      var ang00 = fmod(abs(s.P.ang - s.B.ang), PI/2)
#      var goodand = ang00 > 0.2 and ang00 <
      if colchk.colliding :
#        g.report("bot shoot", [fmod(abs(s.P.ang - s.B.ang), PI)], 0 , 500, {"only":true})
        #g.report("bot shootz", [abs(PI/2 - g.abs_angle(s.P.ang - s.B.ang))], 0 , 500, {"only":true})
        var ang_rel_perp = abs(PI/2 - g.abs_angle(s.P.ang - s.B.ang))
#        if (ang_rel_perp > 0.7 and ammo.size() == 0) or (ammo.size() == 1 and ang_rel_perp > 1.0) or (ammo.size() > 1 and ang_rel_perp > 1.3):
        if ang_rel_perp > 0.9 and ((ang_rel_perp > 0.9 and ammo.size() == 0) or (ammo.size() == 1 and s.B.ang < 0.2) or (ammo.size() > 1 and s.B.ang < 0.1)):
#          if ang_rel_perp > 0.5:
#          var do_shoot = false
          var do_shoot = g.are_equal([ammo.size(),0])
          for sh in aim_shots:
#            g.report("shsh", aim_shots[sh].point, 0 , 1000, {"only":true})
            if (aim_shots[sh].point - colchk.point).length() < 10:
              do_shoot = true
          if do_shoot:
            var mid = shoot_think()
#            g.report("mid", [mid], 0 , 0, {"only":true})
            if not g.is_null(mid):
              g.report("bot shootz", [ammo.size(),ang_rel_perp ], 0 , 0, {"only":false})
              aim_shots[mid] = colchk
              _ph["aim_shots"] = aim_shots
              if ammo.size() == 1 and mid > 0:
                #g.report("missile", [gsvar.missiles[mid]], 0 , 0, {"only":true})
                gsvar.missiles[mid].shotline_mat.set_shader_param( "colbase" , Vector3(0,1,0) )


func _integrate_forces(state):
  if net.replay_state != net.REPLAY_PLAYING:
    calc_move(state)
  ._integrate_forces(state)


func update_radar(delta):
  var r_pos = radar_camera.unproject_position(get_global_transform().origin)
  r_pos.x -= (radar_player.get_size().x / 2.0 + 0.5)
  r_pos.y -= (radar_player.get_size().y / 2.0 - 1)
  radar_player.set_pos(r_pos)
