extends Control

onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var settings = get_node("settings")
onready var g = get_node("/root/global")

func _ready():
	print(["SDFSDF", OS.get_cmdline_args()])
	process_cmd_line()
	gsvar.mainmenu = self;
	update_credits()
	get_node("SelServer/Remote").connect("pressed", get_node("lnIP"), "set_text", ["45.32.180.51"]);
	get_node("SelServer/Local").connect("pressed", get_node("lnIP"), "set_text", ["localhost"]);
	get_node("btnHost").connect("pressed", self, "_btnHost_pressed");
	get_node("btnSolo").connect("pressed", self, "_btnSolo_pressed");
	get_node("btnPractice").connect("pressed", self, "_btnPractice_pressed");
	get_node("btnConnect").connect("pressed", self, "_btnConnect_pressed");
	get_node("btnFullscreen").connect("pressed", self, "_btnFullscreen_pressed");
	get_node("btnQuit").connect("pressed", self, "_btnQuit_pressed");
	get_node("license_button").connect("pressed", get_node("license_popup"), "popup")
	get_node("controls_button").connect("pressed", get_node("controls_popup"), "popup")
	if get_tree().is_debugging_collisions_hint():
		print("WE ARE IN EDITOR")
		g.release = false


# func _init():



func process_cmd_line():
	for i in OS.get_cmdline_args():
		if i == "-norelease":
			g.release = false
		if i == '-sv':
			# g.curlevel = -1
			host_dedicated_server();
		elif i == '-debug0':
			g.curlevel = 0
		elif i == '-cll':
			_btnConnect_pressed('127.0.0.1')
		elif i == '-cls':
			_btnConnect_pressed('45.32.180.51')
		elif i == '-px':
			start_proxy_server('45.32.180.51')
		elif i == '-pxl':
			start_proxy_server('127.0.0.1')
		elif i == '-basketball':
			print("PASDKSDAD")
			g.sg("override_config", {})["host_game_mode"] = "basketball"
			gsvar.config["host_game_mode"] = "basketball"
		elif i == '-football':
			g.sg("override_config", {})["host_game_mode"] = "football"
		elif i == '-hix':
			g.sg("override_config", {})["host_game_mode"] = "hix"
		if i == '-netem':
			netem()
		if i == '-nojs':
			g.jsenabled = false

func netem():
  var contents = "echo "  + str(OS.get_process_ID()) +  " > /sys/fs/cgroup/net_cls/foobar/tasks\n"
  contents += "tc qdisc change dev lo parent 1:2 handle 10:  netem delay 30ms 10ms\n"
#  print(contents)
  g.file_write("res://netemwatch/netem.sh", contents)


#	_btnHost_pressed()

func update_credits():
  var file = File.new()
  file.open("CREDITS", file.READ)
#  print(file.get_as_text())
  var liclable = get_node("license_popup/label")
  var otxt = liclable.get_text()
  liclable.add_text(file.get_as_text())
  file.close()


func set_message(msg):
	get_node("lblMsg").set_text(str(msg));

func _btnHost_pressed():
	print(str(g._store))
#	var name = get_node("lnName").get_text();
	gsvar.config["is_server"] = true
	settings.save_settings()
	var name = gsvar.config.callsign
	var port = get_node("lnPort").get_text().to_int();
	var maxcl = get_node("lnMaxPlayers").get_text().to_int();
	var dedicated = get_node("chkDedicated").is_pressed();

	gsvar.sv_dedicated = dedicated;
	gsvar.cl_name = name;

	if (!gsvar.host_game(port, maxcl)):
#		print("connecting instead")
#		if not _btnConnect_pressed():
#			_btnConnect_pressed()
		return;

	disable_control();


func _btnSolo_pressed():
#	var name = get_node("lnName").get_text();
	gsvar.solo = true
	settings.save_settings()
	var name = gsvar.config.callsign
	var port = get_node("lnPort").get_text().to_int();
	var maxcl = get_node("lnMaxPlayers").get_text().to_int();
	var dedicated = get_node("chkDedicated").is_pressed();

	gsvar.sv_dedicated = dedicated;
	gsvar.cl_name = name;

	if (!gsvar.host_game(port, maxcl)):
#		print("connecting instead")
#		if not _btnConnect_pressed():
#			_btnConnect_pressed()
		return;

	disable_control();

func _btnPractice_pressed():
#	var name = get_node("lnName").get_text();
	gsvar.tutorial = true
	settings.save_settings()
	var name = gsvar.config.callsign
	var port = get_node("lnPort").get_text().to_int();
	var maxcl = get_node("lnMaxPlayers").get_text().to_int();
	var dedicated = get_node("chkDedicated").is_pressed();

	gsvar.sv_dedicated = dedicated;
	gsvar.cl_name = name;

	if (!gsvar.host_game(port, maxcl)):
#		print("connecting instead")
#		if not _btnConnect_pressed():
#			_btnConnect_pressed()
		return;

	disable_control();


func host_dedicated_server():
	gsvar.load_config()
	var name = gsvar.config.callsign
	var port = get_node("lnPort").get_text().to_int();
	var maxcl = get_node("lnMaxPlayers").get_text().to_int();


#	gsvar.sv_dedicated = true;
	gsvar.cl_name = 'server';

	if (!gsvar.host_game(port, maxcl)):
		return;

	disable_control();

func start_proxy_server(ip, sec= false):
	gsvar.load_config()
	var name = 'proxy'
#	var ip = '45.32.180.51'
	var port = 6969;

#	if sec:
#		net.is_proxy2 = true;
#	else:
	net.is_proxy = true;
	gsvar.cl_name = name;

	if (!gsvar.join_game(ip, port)):
		return false;

	disable_control();

func _btnConnect_pressed(force_server=null):
	settings.save_settings()
#	var name = get_node("lnName").get_text();
	var name = gsvar.config.callsign
	var ip = get_node("lnIP").get_text();
	if not g.is_null(force_server):
		ip = force_server
#	var ip = "127.0.0.1"
	var port = get_node("lnPort").get_text().to_int();

	if (!gsvar.join_game(ip, port)):
		return false;

	gsvar.cl_name = name;
	disable_control();

func disable_control():
	get_node("btnHost").set_disabled(true);
	get_node("btnConnect").set_disabled(true);

func enable_control():
	get_node("btnHost").set_disabled(false);
	get_node("btnConnect").set_disabled(false);

	Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE);

func _btnFullscreen_pressed():
	OS.set_window_fullscreen(not OS.is_window_fullscreen())

func _btnQuit_pressed():
	gsvar.request_quit(false)
	# OS.kill(OS.get_process_ID())