extends Control

var messages;
var input;
var animation;
var colors = ["aqua", "fuchsia", "lime", "red", "silver", "teal", "white", "yellow"]
onready var gsvar = get_node("/root/gamestate");
onready var net = get_node("/root/net");

#func _init():
#	gsvar.chatmgr = self;

func _ready():
	gsvar.chatmgr = self;
	messages = get_node("bg/chatMessages");
	messages.set_scroll_follow(true);
	messages.set_scroll_active(false);

	input = get_node("chatInput");
	input.hide();

	animation = get_node("AnimationPlayer");
	animation.play("fade_out");

	set_process_input(true);

func _input(ie):
	if (ie.type == InputEvent.KEY):
		if (ie.pressed && (ie.scancode == KEY_ESCAPE)):
			if (gsvar.active_focus == "CH"):
				messages.set_scroll_active(false);
				input.set_text("");
				input.hide();
#				gsvar.cl_chatting = false;
#				gsvar.restore_focus()
				gsvar.call_deferred("restore_focus")
#				gsvar.focus.pop_back()
				animation.play("fade_out");
		if (ie.pressed && (ie.scancode == KEY_RETURN || ie.scancode == KEY_ENTER)):
			if (gsvar.active_focus == "CH"):
#				net.rpc(self, "send_chat", [net.uid, input.get_text()], {'channel':1});
				send_chat(input.get_text())
				messages.set_scroll_active(false);
				input.set_text("");
				input.hide();

#				gsvar.cl_chatting = false;
				gsvar.restore_focus()
#				gsvar.focus.pop_back()
				animation.play("fade_out");
#				Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED);
#			elif gsvar.focus[-1] == "game":
		if (not ie.pressed && (ie.scancode == KEY_N)):
##			if (input.is_visible() && input.has_focus()):
##			if (gsvar.focus[-1] == "chat"):
#			if (gsvar.active_focus == "CH"):
#				net.rpc(self, "send_chat", [net.uid, input.get_text()], {'channel':1});
#
#				messages.set_scroll_active(false);
#				input.set_text("");
#				input.hide();
#
##				gsvar.cl_chatting = false;
#				gsvar.restore_focus()
##				gsvar.focus.pop_back()
#				animation.play("fade_out");
##				Input.set_mouse_mode(Input.MOUSE_MODE_CAPTURED);
##			elif gsvar.focus[-1] == "game":
#			elif gsvar.active_focus == "GC" or gsvar.active_focus == "GNC":
			if gsvar.active_focus == "GC":
				messages.set_scroll_active(true);
				input.show();
				input.grab_focus();
				input.set_text("");
				animation.play("fade_in");
#				gsvar.cl_chatting = true;
#				gsvar.focus.push_back("chat")
				gsvar.change_focus("CH")
				Input.set_mouse_mode(Input.MOUSE_MODE_VISIBLE);

func send_chat(msg, src=0):
	var id = net.uid
	msg = str(msg).strip_edges();

	if (msg.length() <= 0):
		return;

	if (msg.begins_with("/")):
		msg = msg.substr(1, msg.length()-1);
		get_node("/root/world/console").process_command(msg)
	elif (msg.begins_with(".")):
		msg = msg.substr(1, msg.length()-1);
		msg = msg.split(" ", false);

		if (msg[0] == "online"):
			list_online_players()
		else:
			add_message("Command not found.")
#			net.rpc_id(id, self, "add_message", ["Command not found."]);
		return;
#	if (id == 1 && gsvar.sv_dedicated):
#		msg = "Server: "+msg;
#	else:
#		msg = gsvar.players[id].name +": "+msg;
	if src == 0:
		net.rpc_id(net.primary_server, self, "send_chat", [msg], {"channel":1})
	if net.is_primary:
		if src == 0:
			src = 1
		var player = gsvar.players[src]
		var col = colors[src]
		var out = "[color=" + col + "]" + player.name + "[/color] : " + msg
		net.rpc_sync(self, "add_message", [out]);
#	if (gsvar.sv_dedicated):
#		print("[Chat] ", msg);

func list_online_players(src=0):
	for p in gsvar.get_players():
		get_node("/root/world/gui/chatBox").add_message(p.player_name)
	return
#	if (id == net.uid):
#		add_message("Players Online:");
#	else:
#		net.rpc_id(id,self,  "add_message", ["Players Online:"]);
#
#	var num = 0;
#	for i in gsvar.players.values():
#		i = i.name
#		num += 1;
#		if (id == net.uid):
#			add_message(str(num, ". ", i));
#		else:
#			net.rpc_id(id, self, "add_message", [str(num, ". ", i)]);

func broadcast_msg(msg):
	if (!net.is_primary):
		return;

	net.rpc(self, "add_message", [msg]);
	if (gsvar.sv_dedicated):
		print("[Chat] ", msg);

func send_msg_to(id, msg):
	if (!net.is_primary):
		return;

	net.rpc_id(id, self, "add_message", [msg]);
	if (gsvar.sv_dedicated):
		print("[Chat] ", msg);

func add_message(msg, src=0):
	if (messages.get_text() != ""):
		messages.newline();

#	messages.add_text(msg);
	messages.append_bbcode(msg);

#	if (!gsvar.cl_chatting):
	if (gsvar.focus[-1] != "chat"):
		animation.play("fade_out");
