extends Node

# class member variables go here, for example:
# var a = 2
# var b = "textvar"
onready var gsvar = get_node("/root/gamestate")
onready var net = get_node("/root/net")
onready var me = gsvar.me
onready var global = get_node("/root/global")
onready var g = get_node("/root/global")
onready var ec = g.eval_context()

var cur_section = ""
var cur_step = -1
var step_data = {}
var wait_input = false
var init_step = true
var step_process_input = true
var step_process = true
func _ready():
  # gsvar.announce("Welcome to the crash course!", 0)
  set_process(true);
  set_process_input(true);
  set_pause_mode(2)
  ec.ball().set_translation(Vector3(0,100,0))
  me.shots_limit = 0
  # new_section("welcome")
  new_section("basketball")
  # new_section("shoot")
  # new_section("moving")
  # cur_step = 5
  # next_step()
  # new_section("dribble")
  # new_section("catch")
	# Called every time the node is added to the scene.
	# Initialization here


func _process(delta):
  if step_process and cur_step != -1:
    callv(cur_section + "_" + str(cur_step), [])
  pass

func _input(ie):
  if not step_process_input:
    return
  var f = cur_section + "_" + str(cur_step) + "_input"
  # gsvar.announce([f],1)
  callv(f, [ie])
  pass

func _exit_tree():
  cleanup()
  callv(cur_section + "_" + str(cur_step) + "_cleanup", [])

func step_path():
  return cur_section + "_" + str(cur_step)

func sdi(k):
  step_data[cur_section + "_" + str(cur_step)][k] += 1

func sds(k,v):
  set_step_data(k,v)

func set_step_data(k,v):
  var path = cur_section + "_" + str(cur_step)
  if not step_data.has(path):
    step_data[path] = {}
  step_data[path][k] = v

func sdg(k):
  return get_step_data(k)

func get_step_data(k):
  var path = cur_section + "_" + str(cur_step)
  if  step_data.has(path) and step_data[path].has(k):
    return step_data[path][k]


func is_key_continue(ie):
  if ie.is_pressed() and ie.type == InputEvent.KEY and (ie.scancode == KEY_ENTER or ie.scancode == KEY_RETURN):
    return true
  return false

func is_event_key_pressed(ie,scancode):
  if ie.is_pressed() and ie.type == InputEvent.KEY and not ie.is_echo() and (ie.scancode == scancode):
    return true
  return false

func is_event_key_released(ie,scancode):
  if (not ie.is_pressed()) and ie.type == InputEvent.KEY and (ie.scancode == scancode):
    return true
  return false

# func countdown_holding_key(ie,scancode,n=5, fn=null, args=[]):
func countdown_holding_key(ie,scancode,n=5, fn=null, param={}):
  # gsvar.announce("coundown key event", 1, "2")
  if is_event_key_pressed(ie,scancode):
    # g.object_timer("countdown", self, countdown, true, 1, [n-1])
    countdown(n, fn,param)
  if is_event_key_released(ie,scancode):
    # g.object_timer("countdown", self, countdown, true, 1, [n-1])
    cancel_countdown()

# func countdown(n,fn=null, args=[],step=1.15):
func countdown(n=5,fn=null,param={}):
  # var dparams = {"step":1.5, "args":[], "count":5}
  # params = g.mergedicts(dparams, params)
  param = g.mergedicts({"step":1.15, "args":[]}, param)
  if n == 0:
    if g.is_null(fn):
      fn = cur_section + "_" + str(cur_step) + "_" + "countdown"
      # gsvar.announce(["cd func", fn], 3,"2")
    callv(fn, param.args)
  else:
    # gsvar.announce(str(n), 0.6, "2")
    gsvar.announce(str(n), param.step - 0.35, "", {"top":false})
    n -= 1
    # g.object_timer("countdown", self, "countdown", true, param.step, [n, fn, param], false, true)
    g.object_timer_p("countdown", self, "countdown", {"one":true, "intv":param.step, "args" : [n, fn, param], "replace":true,  "pause_mode":2})

    # countdown(n-1)

func cancel_countdown():
  g.stop_object_timer("countdown", self)


func section_msg(msg):
  # step_data["welcome"] = {"start_at":g.t()}
  cleanup()
  step_data[cur_section]["current_msg"] = gsvar.announce(msg, 0)

func next_step():
  cur_step += 1
  wait_input=false
  init_step = true
  step_process = true
  step_process_input = true
  g.p(false)

func cleanup():
  if step_data.has(cur_section) and step_data[cur_section].has("current_msg"):
    step_data[cur_section]["current_msg"].hide_msg()

func new_section(sec_name):
  gsvar.announce(sec_name,1)
  cleanup()
  cur_section = sec_name
  step_data[sec_name] = {}
  cur_step = -1
  next_step()

func set_target(pos):
  g.ss("follow_target", null)
  if g.is_null(pos):
    g.hide_mark("move_target")
    return
  var mark = pos
  if typeof(pos) == 7: # Vec3
    mark = g.create_mark({"pos":pos, "arrow":true,"arrow_vertical": true, "arrow_shift":Vector3(0,8,0), "label":"target"}, "move_target", true)
  sds("mark", mark)
  g.ss("follow_target", mark)
# func welcome_section_0():

func welcome_0():
  me.stick_x=0
  me.stick_y=0
  g.p(true)
  section_msg("Welcome to the tutorial\nPress Enter to continue")
  countdown(5)
  # wait_input=true
  step_process = false

func welcome_0_countdown():
  new_section("move")

func welcome_0_input(ie):
  # gsvar.announce("input cugh", 1)
  # if ie.type == InputEvent.KEY and ie.scancode == KEY_ENTER:
  # if ie.type == InputEvent.KEY :
  #   gsvar.announce([ie.scancode, KEY_ENTER],1)
  if is_key_continue(ie):
    cancel_countdown()
    new_section("move")
    # next_step()
      # gsvar.announce(ie.scancode, 1, "2")

func move_0():
  if init_step:
    g.p(false)
    # section_msg("Moving the tank\nMove the cursor inside the motion box\n(the outer sqaure in the center of screen)\nUse mouse or keyboard arrows for moving")
    section_msg("Moving the tank\nMove the cursor inside the motion box\nUse mouse or keyboard arrows")
    init_step = false

  if g.is_null(sdg("dist")):
    sds("dist",{"total":0, "lastpos":me.get_translation()})
  #   return
  var d = sdg("dist")
  # print("bababa")
  d.total = d.total + (me.get_translation() - d.lastpos).length()
  # print((me.get_translation() - d.lastpos).length())
  d.lastpos = me.get_translation()
  if d.total > 50:
    next_step()

func move_1():
  if init_step:
    section_msg("follow the arrow to target")
    set_target(Vector3(50,2,50))
    sds("mark_hits", 0)
    init_step = false
    step_process_input=false
    # return
  if (me.get_translation() - sdg("mark").get_translation()).length() < 10:
    sdi("mark_hits")
    set_target(Vector3(randi()%100,2,randi()%200))
  if sdg("mark_hits") > 0:
    # g.hide_mark("move_target")
    set_target(null)
    section_msg("Press Enter to continue")
    # g.p(true)
    step_process = false
    step_process_input = true

func move_1_input(ie):
  if is_key_continue(ie):
    next_step()

func move_2():
  if init_step:
    g.p(false)
    section_msg("Jump using TAB key")
    init_step = false
    step_process = false

func move_2_input(ie):
  if ie.type == InputEvent.KEY and (ie.scancode == KEY_TAB):
    next_step()

func move_3():
  if init_step:
    section_msg("follow the arrow to target, jump to it")
    set_target(Vector3(50,14,50))
    sds("mark_hits", 0)
    init_step = false
    step_process_input=false
  if (me.get_translation() - sdg("mark").get_translation()).length() < 10:
    sdi("mark_hits")
    set_target(Vector3(randi()%100,14,randi()%200))
    if sdg("mark_hits") > 1:
      section_msg("double jump inside the paint to go higher")
      set_target(Vector3(-20 + randi()%40,26,250 + randi()%60))
  if sdg("mark_hits") > 2:
    set_target(null)
    section_msg("Press Enter to continue")
    # g.p(true)
    step_process=false
    step_process_input=true


func move_3_input(ie):
  if is_key_continue(ie):
    next_step()

func move_4():
  if init_step:
    g.p(false)
    section_msg("Sharp turn using Q key while jumping at an angle")
    init_step = false
    step_process = false

func move_4_input(ie):
  if me.phys.resting:
    return
  if ie.type == InputEvent.KEY and (ie.scancode == KEY_Q):
    # if Input.is_key_pressed ( KEY_TAB ):
    #   gsvar.announce("release TAB", 3, "2")
    #   return
    if g.abs_stick(me.stick_x) == 0:
      gsvar.announce("move motion cursor to a side first ", 3, "2")
      return
    next_step()

func move_5():
  if init_step:
    section_msg("try a 180 turn, quickly press Q a few times turning midjump")
    set_target(null)
    sds("mark_hits", 0)
    sds("done_at", 0)
    sds("count", 0)
    init_step = false
    step_process_input=false
  if not me.phys.resting:
    if me.phys_old[-1].resting != me.phys.resting:
      sds("start_jump_rot", me.body_rotation)
    if g.is_null(sdg("start_jump_rot")):
      return
    # print(me.body_rotation - sdg("start_jump_rot"))
    if abs(PI - abs(me.body_rotation - sdg("start_jump_rot"))) < 0.1:
      sdi("count")
      var turn = sdg("count") * 180
      gsvar.announce("you did a "+str(turn)+" turn!", 2, "2")
      sds("start_jump_rot", me.body_rotation)
      sds("done_at", g.t())
      step_process_input=true
      section_msg("Press Enter to continue")
  else:
      sds("count", 0)
  # elif g.t() - sdg("done_at") > 2000:
  #   next_step()

func move_5_input(ie):
  if is_key_continue(ie):
    next_step()

func move_6():
  if init_step:
    g.p(false)
    section_msg("Hold Q while moving on ground to slow down gradually")
    init_step = false
    step_process = false

func move_6_input(ie):
  if not me.phys.resting:
    return
  if ie.type == InputEvent.KEY and (ie.scancode == KEY_Q):
    # if Input.is_key_pressed ( KEY_TAB ):
    #   gsvar.announce("release TAB", 3, "2")
    #   return
    if g.abs_stick(me.stick_x) == 0:
      gsvar.announce("move motion cursor around ", 3, "2")
      return
    countdown_holding_key(ie,KEY_Q, 3, null, {"step":1})
    # next_step()

func move_6_countdown():
  gsvar.announce("On to next section",3)
  next_step()

func move_7():
  if init_step:
    # section_msg("this will be useful later for more fine control\nPress Enter to continue")
    section_msg("Press Enter to continue")
    set_target(null)
    sds("mark_hits", 0)
    sds("done_at", g.t())
    init_step = false
    step_process_input=true
  # if not me.phys.resting:
  #   if me.phys_old[-1].resting != me.phys.resting:
  #     sds("start_jump_rot", me.body_rotation)
  #   # print(me.body_rotation - sdg("start_jump_rot"))
  #   if abs(PI - abs(me.body_rotation - sdg("start_jump_rot"))) < 0.1:
  #     gsvar.announce("you did a 180 turn!", 2, "2")
  #     sds("start_jump_rot", me.body_rotation)
  #     sds("done_at", g.t())
  # if g.t() - sdg("done_at") > 5000:
  #   new_section("basketball")

func move_7_input(ie):
  if is_key_continue(ie):
    # next_step()
    # countdown(3, "new_section", {"args":["basketball"]})
    new_section("basketball")
    # new_section("basketball")



func basketball_0():
  if init_step:
    # ball().ball_follow(1,1)
    ball().ball_reset()
    section_msg("Basketball Basics\nPress Enter to continue")
    g.p(true)
    step_process_input=true
    countdown(5, "new_section", {"args":["dribble"]})
    init_step = false

func basketball_0_input(ie):
  if is_key_continue(ie):
    new_section("dribble")
    cancel_countdown()

func dribble_0():
  if init_step:
    section_msg("Move to the ball and hit it to dribble")
    g.p(false)
    step_process_input=true
    init_step = false
  if g.xz(ball().velocity).length() > 3:
    next_step()

func dribble_0_input(ie):
  pass
  # if is_key_continue(ie):
  #   new_section("dribbling")

func dribble_1():
  if init_step:
    section_msg("Dribble the ball towards target")
    set_target(Vector3(50,12,50))
    sds("mark_hits", 0)
    init_step = false
    step_process_input=false
  if (ball().get_translation() - sdg("mark").get_translation()).length() < 30:
    sdi("mark_hits")
    # set_target(Vector3(randi()%100,2,randi()%200))
    set_target(Vector3(g.randsi(150),2,g.randsi(300)))
    # if sdg("mark_hits") > 1:
    #   set_target(Vector3(-20 + randi()%40,22,250 + randi()%60))
  if sdg("mark_hits") > 1:
    set_target(null)
    section_msg("Press Enter to continue")
    # g.p(true)
    step_process=false
    step_process_input=true


func dribble_1_input(ie):
  if is_key_continue(ie):
    new_section("catch")


func catch_0():
  if init_step:
    section_msg("Hold W as you touch the ball to catch it")
    g.p(false)
    step_process_input=true
    init_step = false
  if ball().owner != -1 and Input.is_key_pressed(KEY_W):
    new_section("throw")

func catch_0_input(ie):
  pass
  # if is_key_continue(ie):
  #   new_section("dribbling")

# $ /ball().last_motion[1] == ball().prev_throw[1]
func throw_0():
  if init_step:
    section_msg("Aim to basket and hold W until the heart fills out then release")
    set_target(g.eval_context().hs().get_translation())
    sds("mark_hits", 0)
    init_step = false
    step_process_input=false
  if ball().last_motion[1] != ball().prev_throw[1] and ball().owner != net.uid:
    if ball().resting or ball().last_motion[1].y > 0 and ball().last_motion[0].y < 10  :
      print("oook")
      ball().catch(net.uid, true)

  if (ball().get_translation() - sdg("mark").get_translation()).length() < 15:
    if ball().prev_throw != sdg("pthrow"):

      sds("pthrow", ball().prev_throw)
      sdi("mark_hits")
      # gsvar.announce(["good throw!", sdg("mark_hits")], 2)
      gsvar.announce("good throw! "+ str(3 - sdg("mark_hits")) + " more to go", 3)
    # set_target(Vector3(randi()%100,2,randi()%200))
    # set_target(Vector3(g.randsi(150),2,g.randsi(300)))
    # if sdg("mark_hits") > 1:
    #   set_target(Vector3(-20 + randi()%40,22,250 + randi()%60))
  if sdg("mark_hits") > 2:
    set_target(null)
    section_msg("Press Enter to continue")
    # g.p(true)
    step_process=false
    step_process_input=true


func throw_0_input(ie):
  if is_key_continue(ie):
    new_section("shoot")

func shoot_0():
  if init_step:
    ball().set_translation(Vector3(0,100,0))
    me.reload_time=0.2
    me.shots_limit = 3
    section_msg("Shoot using any of the following:\nE\nS (hold)\nLeft mouse button\nMouse scroll forward\nTry them and press Enter to continue")
    init_step = false

func shoot_0_input(ie):
  if is_key_continue(ie):
    next_step()

func shoot_1():
  if init_step:
    me.reload_time=3.5
    section_msg("Shoot at the bot")
    step_process_input=false
    step_process=false
    # var ec = g.eval_context()
    # g.remove_bots()
    # ec.setup2()
    g.p(true)
    countdown(3)
    # ec.setup()
    # ec.tmp()
    g.console_exec("/setup()")
    init_step = false
    return
  # print("DSFDSFSDF")
  if bot_dying():
    next_step()


func bot_dying():
  return sdg("bot").is_dying

func shoot_1_countdown():
  # g.console_exec("/setup()")
  # ec.tmp()
  g.p(false)
  ec.bot().paused=true
  set_target(ec.bot())
  step_process=true
  sds("bot", ec.bot())

func shoot_1_input(ie):
  if is_key_continue(ie):
    next_step()

func shoot_2():
  if init_step:
    section_msg("Shoot at the bot")
    step_process_input=false
    ec.bot().paused=false
    set_target(ec.bot())
    sds("last_dead",g.t())
    init_step = false
  if ec.bot().is_dying and g.t() - sdg("last_dead") > 3000:
    sds("last_dead",g.t())
    # section_msg("Press Enter to continue")
    section_msg("You have now completed the basic tutorial!")
    step_process_input=true

func shoot_2_input(ie):
  if is_key_continue(ie):
    next_step()


func ball():
  return g.store_get("recent_ball", get_node("/root/world/env/Ball"))